"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = _default;

var _ccContext = _interopRequireDefault(require("../cc-context"));

var _pendingModules = _interopRequireDefault(require("../cc-context/pending-modules"));

var _constant = require("../support/constant");

var _privConstant = require("../support/priv-constant");

var util = _interopRequireWildcard(require("../support/util"));

var _initModuleState = _interopRequireDefault(require("../core/state/init-module-state"));

var _initModuleReducer = _interopRequireDefault(require("../core/reducer/init-module-reducer"));

var _initModuleComputed = _interopRequireDefault(require("../core/computed/init-module-computed"));

var _initModuleWatch = _interopRequireDefault(require("../core/watch/init-module-watch"));

var _initModuleLifecycle = _interopRequireDefault(require("../core/base/init-module-lifecycle"));

var _getLifecycle = _interopRequireDefault(require("../core/param/get-lifecycle"));

var _plugin = require("../core/plugin");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/** @typedef {import('../types').ModuleConfig} ModuleConfig */

/** @typedef {import('../types').ConfOptions} ConfOptions */
var isPJO = util.isPJO,
    evalState = util.evalState,
    okeys = util.okeys,
    isFn = util.isFn;
/**
 * @description configure module associate params
 * @author zzk
 * @export
 * @param {string | {[module:string]: ModuleConfig}} moduleNameOrNamedModuleConf
 * @param {ModuleConfig | ConfOptions } config - when module type is string
 */

function _default(moduleNameOrNamedModuleConf, config, innerParams) {
  if (config === void 0) {
    config = {};
  }

  var confOneModule = function confOneModule(module,
  /** @type ModuleConfig*/
  config, allowDup) {
    if (allowDup === void 0) {
      allowDup = false;
    }

    if (!_ccContext["default"].isStartup) {
      _pendingModules["default"].push({
        module: module,
        config: config
      });

      return;
    }

    if (!isPJO(config)) {
      throw new Error("param config " + _privConstant.INAJ);
    }

    if (module === _constant.MODULE_GLOBAL) {
      throw new Error('configuring global module is not allowed');
    }

    if (allowDup && _ccContext["default"].store.getState(module)) {
      return;
    }

    var state = config.state,
        reducer = config.reducer,
        computed = config.computed,
        watch = config.watch,
        _config$ghosts = config.ghosts,
        ghosts = _config$ghosts === void 0 ? [] : _config$ghosts;
    var eState = evalState(state);
    if (isFn(state)) _ccContext["default"].moduleName2stateFn[module] = state; // 运行重复且已存在，则直接忽略此模块

    (0, _initModuleState["default"])(module, eState, true, innerParams);
    (0, _initModuleReducer["default"])(module, reducer, ghosts);
    (0, _initModuleComputed["default"])(module, computed);
    (0, _initModuleWatch["default"])(module, watch);
    (0, _initModuleLifecycle["default"])(module, (0, _getLifecycle["default"])(config));
    _ccContext["default"].moduleName2isConfigured[module] = true;
    (0, _plugin.send)(_constant.SIG_MODULE_CONFIGURED, module);
  }; // now module is an object that includes partial store conf


  if (isPJO(moduleNameOrNamedModuleConf)) {
    var allowDup = false;
    if (isPJO(config)) allowDup = config.allowDup === true;
    okeys(moduleNameOrNamedModuleConf).forEach(function (moduleName) {
      return confOneModule(moduleName, moduleNameOrNamedModuleConf[moduleName], allowDup);
    });
  } else {
    confOneModule(moduleNameOrNamedModuleConf, config);
  }
}