"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = _default;

var _configure2 = _interopRequireDefault(require("../api/configure"));

var _privConstant = require("../support/priv-constant");

var _getModuleName = _interopRequireDefault(require("../core/param/get-module-name"));

/** @typedef {import('../types').ModuleConfig} ModuleTemplate */

/** @typedef {import('../types').RegisteredModule} RegisteredModule */

/**
 * 调用 configure 配置模块模板，并返回已注册模块
 * @param {ModuleTemplate} moduleTemplate 
 * @param {string} moduleNameOrTag 
 * @param {boolean} asTag 
 * @return {RegisteredModule}
 */
function _default(moduleTemplate, moduleNameOrTag, asTag) {
  var _configure, _Object$assign;

  if (asTag === void 0) {
    asTag = false;
  }

  var finalModuleName = (0, _getModuleName["default"])(moduleNameOrTag, asTag);
  var allowCcPrefixFlag = asTag === true ? 1 : 0;
  (0, _configure2["default"])(finalModuleName, moduleTemplate, (_configure = {}, _configure[_privConstant.ALCC_KEY] = allowCcPrefixFlag, _configure));
  var registeredModule = Object.assign({}, moduleTemplate, (_Object$assign = {
    __regModule__: finalModuleName
  }, _Object$assign[_privConstant.REG_MODULE_KEY] = 1, _Object$assign));
  return registeredModule;
}