"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = _default;

var _startup = _interopRequireDefault(require("./startup"));

var util = _interopRequireWildcard(require("../support/util"));

var _privConstant = require("../support/priv-constant");

var _ccContext = _interopRequireDefault(require("../cc-context"));

var _pendingModules = _interopRequireDefault(require("../cc-context/pending-modules"));

var _getLifecycle = _interopRequireDefault(require("../core/param/get-lifecycle"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/** @typedef {import('../types').ModuleConfig} ModuleConfig */
var isPJO = util.isPJO,
    okeys = util.okeys,
    isFn = util.isFn;

var pError = function pError(label) {
  throw new Error("[[run]]: param error, " + label + " " + _privConstant.INAJ);
};
/**
 * run will call startup
 * @param {{ [moduleName:string]: ModuleConfig }} store
 * @param {import('../types').RunOptions} options
 */


function _default(store, options) {
  if (store === void 0) {
    store = {};
  }

  if (options === void 0) {
    options = {};
  }

  if (!isPJO(store)) pError('store');
  if (!isPJO(options)) pError('options');
  var storeConf = {
    store: {},
    reducer: {},
    ghost: {},
    watch: {},
    computed: {},
    lifecycle: {}
  };

  var buildStoreConf = function buildStoreConf(m, moduleConf) {
    var state = moduleConf.state,
        reducer = moduleConf.reducer,
        watch = moduleConf.watch,
        computed = moduleConf.computed,
        _moduleConf$ghosts = moduleConf.ghosts,
        ghosts = _moduleConf$ghosts === void 0 ? [] : _moduleConf$ghosts;

    if (storeConf.store[m]) {
      throw new Error("run api error: module[" + m + "] duplicate");
    }

    if (isFn(state)) _ccContext["default"].moduleName2stateFn[m] = state;
    storeConf.store[m] = state;
    storeConf.reducer[m] = reducer;
    storeConf.ghost[m] = ghosts;
    storeConf.watch[m] = watch;
    storeConf.computed[m] = computed;
    storeConf.lifecycle[m] = (0, _getLifecycle["default"])(moduleConf);
  }; // traversal moduleNames


  okeys(store).forEach(function (m) {
    return buildStoreConf(m, store[m]);
  }); // these modules pushed by configure api before calling run

  _pendingModules["default"].forEach(function (_ref) {
    var module = _ref.module,
        config = _ref.config;
    // user put this module to run api 1th models param again, here just ignore this one
    if (storeConf.store[module]) return; // configure pending module

    buildStoreConf(module, config);
  });

  _pendingModules["default"].length = 0; // clear pending modules

  (0, _startup["default"])(storeConf, options);
}