"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;
exports.getCcContext = getCcContext;

var _computedMap = _interopRequireDefault(require("./computed-map"));

var _watchMap = _interopRequireDefault(require("./watch-map"));

var _runtimeVar = _interopRequireDefault(require("./runtime-var"));

var _runtimeHandler = _interopRequireDefault(require("./runtime-handler"));

var _wakeyUkeyMap = require("./wakey-ukey-map");

var _modueInsCountMap = _interopRequireDefault(require("./modue-ins-count-map"));

var _internalVars = require("./internal-vars");

var _lifecycle = _interopRequireDefault(require("./lifecycle"));

var _constant = require("../support/constant");

var util = _interopRequireWildcard(require("../support/util"));

var _pickDepFns = _interopRequireDefault(require("../core/base/pick-dep-fns"));

var _findDepFnsToExecute3 = _interopRequireDefault(require("../core/base/find-dep-fns-to-execute"));

var _extractStateByKeys2 = _interopRequireDefault(require("../core/state/extract-state-by-keys"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/* eslint-disable camelcase */
var _computedValues = _computedMap["default"]._computedValues;
var okeys = util.okeys,
    extractChangedState = util.extractChangedState;

var getDispatcher = function getDispatcher() {
  return _internalVars.permanentDispatcherRef.value;
};

var setStateByModule = function setStateByModule(module, committedState, opts) {
  if (opts === void 0) {
    opts = {};
  }

  var _opts = opts,
      _opts$ref = _opts.ref,
      ref = _opts$ref === void 0 ? null : _opts$ref,
      _opts$callInfo = _opts.callInfo,
      callInfo = _opts$callInfo === void 0 ? {} : _opts$callInfo,
      _opts$noSave = _opts.noSave,
      noSave = _opts$noSave === void 0 ? false : _opts$noSave,
      force = _opts.force;

  var moduleState = _getState(module);

  var moduleComputedValue = _computedValues[module];

  var rootComputedDep = _computedMap["default"].getRootComputedDep();

  var curDepComputedFns = function curDepComputedFns(committedState, isFirstCall) {
    return (0, _pickDepFns["default"])(isFirstCall, _constant.CATE_MODULE, 'computed', rootComputedDep, module, moduleState, committedState);
  };

  var rootWatchDep = _watchMap["default"].getRootWatchDep();

  var curDepWatchFns = function curDepWatchFns(committedState, isFirstCall) {
    return (0, _pickDepFns["default"])(isFirstCall, _constant.CATE_MODULE, 'watch', rootWatchDep, module, moduleState, committedState);
  };

  var callerRef = ref || getDispatcher();
  var refModule = callerRef.module;
  var newState = Object.assign({}, moduleState, committedState);
  var deltaCommittedState = Object.assign({}, committedState);

  var _findDepFnsToExecute = (0, _findDepFnsToExecute3["default"])(callerRef, module, refModule, moduleState, curDepComputedFns, deltaCommittedState, newState, deltaCommittedState, callInfo, false, _constant.FN_CU, _constant.CATE_MODULE, moduleComputedValue),
      hasDeltaInCu = _findDepFnsToExecute.hasDelta;

  var _findDepFnsToExecute2 = (0, _findDepFnsToExecute3["default"])(callerRef, module, refModule, moduleState, curDepWatchFns, deltaCommittedState, newState, deltaCommittedState, callInfo, false, _constant.FN_WATCH, _constant.CATE_MODULE, moduleComputedValue),
      hasDeltaInWa = _findDepFnsToExecute2.hasDelta;

  if (!noSave) {
    saveSharedState(module, deltaCommittedState, false, force);
  }

  return {
    hasDelta: hasDeltaInCu || hasDeltaInWa,
    deltaCommittedState: deltaCommittedState
  };
};

var saveSharedState = function saveSharedState(module, toSave, needExtract, force) {
  if (needExtract === void 0) {
    needExtract = false;
  }

  var target = toSave;

  if (needExtract) {
    var _extractStateByKeys = (0, _extractStateByKeys2["default"])(toSave, _internalVars.moduleName2stateKeys[module], true),
        partialState = _extractStateByKeys.partialState;

    target = partialState;
  }

  var moduleState = _getState(module);

  var prevModuleState = _getPrevState(module);

  incModuleVer(module); // 调用 extractChangedState 时会更新 moduleState

  return extractChangedState(moduleState, target, {
    prevStateContainer: prevModuleState,
    incStateVer: function incStateVer(key) {
      return _incStateVer(module, key);
    }
  }, force);
};

var _getState = function getState(module) {
  return _internalVars._state[module];
};

var _getPrevState = function getPrevState(module) {
  return _internalVars._prevState[module];
};

var getModuleVer = function getModuleVer(module) {
  if (!module) return _moduleVer;
  return _moduleVer[module];
};

var incModuleVer = function incModuleVer(module, val) {
  if (val === void 0) {
    val = 1;
  }

  try {
    _moduleVer[module] += val;
  } catch (err) {
    _moduleVer[module] = val;
  }
};

function replaceMV(mv) {
  _moduleVer = mv;
}

var getStateVer = function getStateVer(module) {
  if (!module) return _stateVer;
  return _stateVer[module];
};

var _incStateVer = function _incStateVer(module, key) {
  _stateVer[module][key]++;
};
/** ccContext section */
// record state version, to let ref effect avoid endless execute
// 1 effect里的函数再次出发当前实例渲染，渲染完后检查prevModuleState curModuleState, 对应的key值还是不一样，又再次出发effect，造成死循环
// 2 确保引用型值是基于原有引用修改某个属性的值时，也能触发effect


var _stateVer = {}; // 优化before-render里无意义的merge mstate导致冗余的set（太多的set会导致 Maximum call stack size exceeded）
// https://codesandbox.io/s/happy-bird-rc1t7?file=/src/App.js concent below 2.4.18会触发

var _moduleVer = {};
var ccContext = {
  getDispatcher: getDispatcher,
  isHotReloadMode: function isHotReloadMode() {
    if (ccContext.isHot) return true;
    return window && (window.webpackHotUpdate || util.isOnlineEditor());
  },
  runtimeVar: _runtimeVar["default"],
  runtimeHandler: _runtimeHandler["default"],
  isHot: false,
  reComputed: true,
  isStartup: false,
  moduleName2stateFn: {},
  // 映射好模块的状态所有key并缓存住，用于提高性能
  moduleName2stateKeys: _internalVars.moduleName2stateKeys,
  // 记录模块是不是通过configure配置的
  moduleName2isConfigured: {},

  /**
   * ccClassContext:{
   *   module,
   *   ccClassKey,
   *   // renderKey机制影响的类范围，默认只影响调用者所属的类，如果有别的类观察了同一个模块的某个key，这个类的实例是否触发渲染不受renderKey影响
   *   // 为 * 表示影响所有的类，即其他类实例都受renderKey机制影响。
   *   renderKeyClasses, 
   * }
  */
  ccClassKey2Context: {},

  /**
   * globalStateKeys is maintained by cc automatically,
   * when user call cc.setGlobalState, or ccInstance.setGlobalState,
   * committedState will be checked strictly by cc with globalStateKeys,
   * committedState keys must been included in globalStateKeys
   */
  globalStateKeys: [],
  // store里的setState行为会自动触发模块级别的computed、watch函数
  store: {
    appendState: function appendState(module, state) {
      if (!_internalVars.moduleName2stateKeys[module]) throw new Error("module[" + module + "] not configured");
      var stateKeys = util.safeGetArray(_internalVars.moduleName2stateKeys, module);
      okeys(state).forEach(function (k) {
        if (!stateKeys.includes(k)) {
          stateKeys.push(k);
        }
      });
      ccContext.store.setState(module, state);
    },
    _state: _internalVars._state,
    _prevState: _internalVars._prevState,
    // 辅助effect逻辑用
    _stateVer: _stateVer,
    // 触发时，比较state版本，防止死循环
    getState: function getState(module) {
      if (module) return _getState(module);else return _internalVars._state;
    },
    getPrevState: function getPrevState(module) {
      if (module) return _getPrevState(module);else return _internalVars._prevState;
    },
    getStateVer: getStateVer,
    getModuleVer: getModuleVer,
    incModuleVer: incModuleVer,
    replaceMV: replaceMV,
    setState: function setState(module, partialSharedState, options) {
      return setStateByModule(module, partialSharedState, options);
    },
    setGlobalState: function setGlobalState(partialGlobalState) {
      return setStateByModule(_constant.MODULE_GLOBAL, partialGlobalState);
    },
    saveSharedState: saveSharedState,
    getGlobalState: function getGlobalState() {
      return _internalVars._state[_constant.MODULE_GLOBAL];
    }
  },
  reducer: _internalVars.reducer,
  computed: _computedMap["default"],
  watch: _watchMap["default"],
  refStore: {
    _state: {},
    setState: function setState(ccUniqueKey, partialStoredState) {
      var _state = ccContext.refStore._state;
      var fullStoredState = _state[ccUniqueKey];
      var mergedState = Object.assign({}, fullStoredState, partialStoredState);
      _state[ccUniqueKey] = mergedState;
    }
  },
  lifecycle: _lifecycle["default"],
  ccUKey2ref: _internalVars.refs,

  /**
   * key:eventName,  value: Array<{ccKey, identity,  handlerKey}>
   */
  event2handlers: {},
  ccUKey2handlerKeys: {},

  /**
   * to avoid memory leak, the handlerItem of event2handlers just store handlerKey, 
   * it is a ref that towards ccUniqueKeyEvent_handler_'s key
   * when component unmounted, its handler will been removed
   */
  handlerKey2handler: {},
  waKey2uKeyMap: _wakeyUkeyMap.waKey2uKeyMap,
  waKey2staticUKeyMap: _wakeyUkeyMap.waKey2staticUKeyMap,
  module2insCount: _modueInsCountMap["default"],
  refs: _internalVars.refs,
  info: {
    packageLoadTime: Date.now(),
    firstStartupTime: '',
    latestStartupTime: '',
    version: '2.21.6',
    author: 'fantasticsoul',
    emails: ['624313307@qq.com', 'zhongzhengkai@gmail.com'],
    tag: 'glory'
  },
  featureStr2classKey: {},
  userClassKey2featureStr: {},
  middlewares: [],
  plugins: [],
  pluginNameMap: {},
  localStorage: null,
  recoverRefState: util.noop,
  getModuleStateKeys: function getModuleStateKeys(m) {
    return _internalVars.moduleName2stateKeys[m];
  }
};

ccContext.recoverRefState = function () {
  var localStorage = ccContext.localStorage;
  if (!localStorage) return;
  var lsLen = localStorage.length;
  var _refStoreState = ccContext.refStore._state;

  try {
    for (var i = 0; i < lsLen; i++) {
      var lsKey = localStorage.key(i);
      if (!lsKey.startsWith('CCSS_')) return;
      _refStoreState[lsKey.substring(5)] = JSON.parse(localStorage.getItem(lsKey));
    }
  } catch (err) {
    util.logErr(err);
  }
};

function getCcContext() {
  return ccContext;
}

var _default = ccContext;
exports["default"] = _default;