"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _util = require("../support/util");

var _runtimeVar = _interopRequireDefault(require("./runtime-var"));

var defaultErrorHandler = function defaultErrorHandler(err, silent) {
  if (silent === void 0) {
    silent = false;
  }

  var logFn = _runtimeVar["default"].isDebug ? _util.logWarn : _util.logErr; // 避免travis 发现 error 打印就导致 test 用例不通过

  logFn('found uncaught err, suggest configure an errorHandler in run options');
  logFn(err);
  if (!silent) throw err;
};

var rh = {
  act: null,
  immutLib: null,
  errorHandler: null,
  warningHandler: null,
  tryHandleError: function tryHandleError(err, silent) {
    rh.errorHandler ? rh.errorHandler(err) : defaultErrorHandler(err, silent);
  },
  tryHandleWarning: function tryHandleWarning(err) {
    // this kind of error will not lead to app crash, but should let developer know
    (0, _util.justWarning)(err);
    rh.warningHandler && rh.warningHandler(err);
  }
};
var _default = rh;
exports["default"] = _default;