"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var React = _interopRequireWildcard(require("react"));

var util = _interopRequireWildcard(require("../support/util"));

var _beforeUnmount = _interopRequireDefault(require("../core/base/before-unmount"));

var _didMount = _interopRequireDefault(require("../core/base/did-mount"));

var _didUpdate = _interopRequireDefault(require("../core/base/did-update"));

var _getOutProps = _interopRequireDefault(require("../core/base/get-out-props"));

var _initCcFrag = _interopRequireDefault(require("../core/ref/init-cc-frag"));

var _beforeRender = _interopRequireDefault(require("../core/ref/before-render"));

var _isRegChanged = _interopRequireDefault(require("../core/param/is-reg-changed"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/* eslint-disable */
var shallowDiffers = util.shallowDiffers,
    isFn = util.isFn;
var nullSpan = React.createElement('span', {
  style: {
    display: 'none'
  }
});

var CcFragment = /*#__PURE__*/function (_React$Component) {
  (0, _inheritsLoose2["default"])(CcFragment, _React$Component);

  function CcFragment(props, context) {
    var _this;

    _this = _React$Component.call(this, props, context) || this;
    (0, _initCcFrag["default"])((0, _assertThisInitialized2["default"])(_this), props);
    return _this;
  }

  var _proto = CcFragment.prototype;

  _proto.componentDidMount = function componentDidMount() {
    (0, _didMount["default"])(this);
  };

  _proto.shouldComponentUpdate = function shouldComponentUpdate(nextProps, nextState) {
    var props = (0, _getOutProps["default"])(nextProps);
    var isPropsChanged = this.__$$compareProps ? shallowDiffers(props, (0, _getOutProps["default"])(this.props)) : false; // 检测到register已发送变化，需要重新走一把卸载和初始化流程

    if (isPropsChanged && (0, _isRegChanged["default"])(props.register, this.props.register)) {
      (0, _beforeUnmount["default"])(this);
      (0, _initCcFrag["default"])(this, props);
      (0, _didMount["default"])(this);
      this.ctx.reactForceUpdate();
      return false;
    }

    return this.state !== nextState || isPropsChanged;
  } // componentDidUpdate(prevProps, prevState) {
  ;

  _proto.componentDidUpdate = function componentDidUpdate() {
    (0, _didUpdate["default"])(this);
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    (0, _beforeUnmount["default"])(this);
  };

  _proto.render = function render() {
    // 注意这里，一定要每次都取最新的绑在ctx上，确保交给renderProps的ctx参数里的state和props是最新的
    var thisProps = this.props;
    this.ctx.prevProps = this.ctx.props;
    this.ctx.props = (0, _getOutProps["default"])(thisProps); // eslint-disable-next-line

    var children = thisProps.children,
        render = thisProps.render,
        _thisProps$register = thisProps.register,
        register = _thisProps$register === void 0 ? {} : _thisProps$register;
    var view = render || children;

    if (isFn(view)) {
      (0, _beforeRender["default"])(this, register.mapProps);
      return view(this.ctx) || nullSpan; // return view(this.ctx.__$$mapped) || nullSpan;
    } else {
      if (React.isValidElement(view)) {
        // 直接传递dom，无论state怎么改变都不会再次触发渲染
        throw new Error("CcFragment's children can not be a react dom");
      }

      return view;
    }
  };

  return CcFragment;
}(React.Component);

var _default = CcFragment;
exports["default"] = _default;