"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _useConcent = require("../core/hook/use-concent");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/* eslint-disable react/prop-types,react/display-name */

/**
 * inspired by mobx's <Observer>{state=>state.name}</Observer>
 */
var obView = function obView() {
  return 'miss render prop or children';
};

var TargetComp = function TargetComp() {
  return React.createElement('h1', {}, 'Ob component needs react ver lte 16.8');
};

if (React.memo) {
  TargetComp = React.memo(function (
  /** @type any */
  props) {
    var module = props.module,
        connect = props.connect,
        classKey = props.classKey,
        render = props.render,
        children = props.children;

    if (module && connect) {
      throw new Error('module, connect can not been supplied both');
    } else if (!module && !connect) {
      throw new Error('module or connect should been supplied');
    }

    var view = render || children || obView;
    var register = module ? {
      module: module
    } : {
      connect: connect
    }; // 设置为1，最小化ctx够造过程，仅附加状态数据，衍生数据、和reducer相关函数

    register.lite = 1;
    var ctx = (0, _useConcent.useConcentForOb)(register, classKey);
    var mr = ctx.mr,
        cr = ctx.cr,
        r = ctx.r;
    var state, computed;

    if (module) {
      state = ctx.moduleState;
      computed = ctx.moduleComputed;
    } else {
      state = ctx.connectedState;
      computed = ctx.connectedComputed;
    }

    return view([state, computed, {
      mr: mr,
      cr: cr,
      r: r
    }]);
  });
}

TargetComp.displayName = 'Ob';
var _default = TargetComp;
exports["default"] = _default;