"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var util = _interopRequireWildcard(require("../../support/util"));

var _constant = require("../../support/constant");

var _privConstant = require("../../support/priv-constant");

var _triggerComputedAndWatch = _interopRequireDefault(require("./trigger-computed-and-watch"));

var _ccContext = _interopRequireDefault(require("../../cc-context"));

var _makeCuRetContainer = _interopRequireDefault(require("../computed/make-cu-ret-container"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/** @typedef {import('../../types-inner').IRef} IRef */

/** @typedef {import('../../types').MultiComputed} MultiComputed */

/** @typedef {import('../../types').MultiComputedFn} MultiComputedFn */
var okeys = util.okeys,
    makeCuDepDesc = util.makeCuDepDesc,
    isFn = util.isFn;
var runtimeVar = _ccContext["default"].runtimeVar;
/**
 * @param {IRef} ref
 * @param {Function} setup
 * @param {boolean} bindCtxToMethod
 * @param {MultiComputed | MultiComputedFn} cuDesc
 */

function beforeMount(ref, setup, bindCtxToMethod, cuDesc) {
  var ctx = ref.ctx;
  ref.__$$ms = _constant.NOT_MOUNT; // flag ref is at before mount step

  ctx.__$$inBM = true; // 先调用setup，setup可能会定义computed,watch，同时也可能调用ctx.reducer,所以setup放在fill reducer之后

  if (setup) {
    var tip = 'type of setup';
    if (!isFn(setup)) throw new Error(tip + " " + _privConstant.INAF);
    var settingsObj = setup(ctx) || {};
    if (!util.isPJO(settingsObj)) throw new Error(tip + " return result " + _privConstant.INAJ); // 优先读自己的，再读全局的

    if (bindCtxToMethod === true || runtimeVar.bindCtxToMethod === true && bindCtxToMethod !== false) {
      okeys(settingsObj).forEach(function (name) {
        var settingValue = settingsObj[name];
        if (isFn(settingValue)) settingsObj[name] = settingValue.bind(ref, ctx);
      });
    }

    Object.assign(ctx.settings, settingsObj);
  } // v2.13.1+ 支持外部传入refComputed函数定义


  if (cuDesc) ctx.computed(cuDesc); // !!! 把拦截了setter getter的计算结果容器赋值给refComputed
  // 这一波必需在setup调用之后做，因为setup里会调用ctx.computed写入 computedRetKeyFns 等元数据

  ctx.refComputedValues = (0, _makeCuRetContainer["default"])(ctx.computedRetKeyFns, ctx.refComputedRawValues); // 所有的组件都会自动连接到$$global模块，但是有可能没有使用$$global模块数据做过任何实例计算
  // 这里需要补齐computedDep.$$global 和 watchDep.$$global 的依赖描述数据
  // 防止后续逻辑里出错

  var computedDep = ctx.computedDep,
      watchDep = ctx.watchDep;

  if (!computedDep[_constant.MODULE_GLOBAL]) {
    computedDep[_constant.MODULE_GLOBAL] = makeCuDepDesc();
  }

  if (!watchDep[_constant.MODULE_GLOBAL]) {
    watchDep[_constant.MODULE_GLOBAL] = makeCuDepDesc();
  }

  (0, _triggerComputedAndWatch["default"])(ref);
  ctx.__$$inBM = false;
}

var _default = beforeMount;
exports["default"] = _default;