"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = beforeUnmount;

var _util = require("../../support/util");

var _constant = require("../../support/constant");

var _wakeyUkeyMap = require("../../cc-context/wakey-ukey-map");

var ev = _interopRequireWildcard(require("../event"));

var _unsetRef = _interopRequireDefault(require("../ref/unset-ref"));

var refCache = _interopRequireWildcard(require("../ref/_cache"));

var _modueInsCountMap = _interopRequireDefault(require("../../cc-context/modue-ins-count-map"));

var _lifecycle2 = _interopRequireDefault(require("../../cc-context/lifecycle"));

var _handlerFactory = require("../state/handler-factory");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _lifecycle = _lifecycle2["default"]._lifecycle,
    _willUnmountOnce = _lifecycle2["default"]._willUnmountOnce;

function executeClearCb(cbMap, ctx) {
  var execute = function execute(key) {
    // symbolKey or normalKey
    var cb = cbMap[key];
    if ((0, _util.isFn)(cb)) cb(ctx);
  };

  Object.getOwnPropertySymbols(cbMap).forEach(execute);
  (0, _util.okeys)(cbMap).forEach(execute);
}

function triggerLifecycleWillUnmount(allModules, mstate) {
  var handleOneModule = function handleOneModule(m) {
    _modueInsCountMap["default"][m] -= 1;
    var moduleLifecycle = _lifecycle[m];
    if (!moduleLifecycle) return;
    var willUnmount = moduleLifecycle.willUnmount;
    if (!willUnmount) return;
    if (_willUnmountOnce[m] === true) return;

    if (_modueInsCountMap["default"][m] === 0) {
      var once = willUnmount((0, _handlerFactory.makeModuleDispatcher)(m), mstate);
      _willUnmountOnce[m] = (0, _util.getVal)(once, true);
    }
  };

  allModules.forEach(handleOneModule);
}

function beforeUnmount(ref) {
  // 标记一下已卸载，防止组件卸载后，某个地方有异步的任务拿到了该组件的引用，然后执行setState，导致
  // Warning: Can't perform a React state update on an unmounted component. This is a no-op ......
  var curMs = ref.__$$ms;
  ref.__$$ms = _constant.UNMOUNTED;
  var ctx = ref.ctx;
  var ccUniqueKey = ctx.ccUniqueKey,
      module = ctx.module,
      allModules = ctx.allModules,
      __$$staticWaKeyList = ctx.__$$staticWaKeyList,
      __$$mstate = ctx.__$$mstate; // 正常情况下只有挂载了组件才会有effect等相关定义

  if (curMs === _constant.MOUNTED) {
    var _ctx$effectMeta = ctx.effectMeta,
        eid2effectReturnCb = _ctx$effectMeta.eid2effectReturnCb,
        eid2effectPropsReturnCb = _ctx$effectMeta.eid2effectPropsReturnCb;
    executeClearCb(eid2effectReturnCb, ctx);
    executeClearCb(eid2effectPropsReturnCb, ctx);
    ev.offEventHandlersByCcUniqueKey(ccUniqueKey);
  } // 删除记录的动态依赖


  var waKeys = ctx.getWatchedKeys(); // no module prefix

  waKeys.forEach(function (k) {
    return (0, _wakeyUkeyMap.delIns)(module, k, ccUniqueKey);
  });
  var connWaKeys = ctx.getConnectWatchedKeys();
  (0, _util.okeys)(connWaKeys).map(function (m) {
    var waKeys = connWaKeys[m];
    waKeys.forEach(function (k) {
      return (0, _wakeyUkeyMap.delIns)(m, k, ccUniqueKey);
    });
  }); // 删除记录的静态依赖

  __$$staticWaKeyList.forEach(function (modStateKey) {
    return (0, _wakeyUkeyMap.delStaticInsM)(modStateKey, ccUniqueKey);
  }); // let findUpdateRefs cache expire


  allModules.forEach(refCache.createModuleNode);
  (0, _unsetRef["default"])(ccUniqueKey);
  triggerLifecycleWillUnmount(allModules, __$$mstate);
}