"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = _default;

var util = _interopRequireWildcard(require("../../support/util"));

var _internalVars = require("../../cc-context/internal-vars");

var _pickOneRef = _interopRequireDefault(require("../../core/ref/pick-one-ref"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var makeUniqueCcKey = util.makeUniqueCcKey,
    justWarning = util.justWarning;

var resolve = function resolve() {
  return Promise.resolve();
};

function _default(action, payLoadWhenActionIsString, rkOrOptions, delay, options) {
  if (rkOrOptions === void 0) {
    rkOrOptions = '';
  }

  if (options === void 0) {
    options = {};
  }

  var _options = options,
      ccClassKey = _options.ccClassKey,
      ccKey = _options.ccKey,
      _options$throwError = _options.throwError,
      throwError = _options$throwError === void 0 ? true : _options$throwError,
      _options$refModule = _options.refModule,
      refModule = _options$refModule === void 0 ? '' : _options$refModule;

  if (action === undefined && payLoadWhenActionIsString === undefined) {
    throw new Error("params type error");
  }

  var dispatchFn,
      module = '',
      fnName = '';

  try {
    if (ccClassKey && ccKey) {
      var uKey = makeUniqueCcKey(ccClassKey, ccKey);
      var targetRef = _internalVars.refs[uKey];

      if (!targetRef) {
        justWarning("no ref found for ccUniqueKey:" + uKey + "!");
        return resolve();
      } else {
        dispatchFn = targetRef.ctx.dispatch;
      }
    } else {
      if (typeof action == 'string') {
        if (action.includes('/')) {
          var _action$split = action.split('/'),
              m = _action$split[0],
              name = _action$split[1];

          module = m;
          fnName = name;
        } else {
          fnName = action;
        }
      }

      var ref;

      if (module && module !== '*') {
        try {
          ref = (0, _pickOneRef["default"])(module);
        } catch (err) {// do nothing
        }
      } else if (refModule) {
        ref = (0, _pickOneRef["default"])(refModule);
      }

      if (!ref) {
        ref = (0, _pickOneRef["default"])();
      }

      dispatchFn = ref.ctx.dispatch;
    }

    if (module === '*') {
      var fullFnNames = _internalVars.reducer._fnName2fullFnNames[fnName];
      if (!fullFnNames) return;
      var tasks = [];
      fullFnNames.forEach(function (fullFnName) {
        tasks.push(dispatchFn(fullFnName, payLoadWhenActionIsString, rkOrOptions, delay));
      });
      return Promise.all(tasks);
    } else {
      return dispatchFn(action, payLoadWhenActionIsString, rkOrOptions, delay);
    }
  } catch (err) {
    if (throwError) throw err;else {
      justWarning(err.message);
      return resolve();
    }
  }
}