"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = _default;

var _ccContext = _interopRequireDefault(require("../../cc-context"));

var _handlerFactory = require("../state/handler-factory");

var _util = require("../../support/util");

var getState = _ccContext["default"].store.getState;

function _default(moduleName, lifecycle) {
  if (lifecycle === void 0) {
    lifecycle = {};
  }

  var _lifecycle = lifecycle,
      initState = _lifecycle.initState,
      initStateDone = _lifecycle.initStateDone,
      loaded = _lifecycle.loaded,
      willUnmount = _lifecycle.willUnmount,
      mounted = _lifecycle.mounted; // 对接原来的 moduleConf.init initPost

  var validLifecycle = {};
  if ((0, _util.isFn)(willUnmount)) validLifecycle.willUnmount = willUnmount;
  if ((0, _util.isFn)(mounted)) validLifecycle.mounted = mounted;
  _ccContext["default"].lifecycle._lifecycle[moduleName] = validLifecycle;
  var moduleState = getState(moduleName);
  var d = (0, _handlerFactory.makeModuleDispatcher)(moduleName); // loaded just means that module state、reducer、watch、computed configuration were recorded to ccContext
  // so it is called before initState

  if ((0, _util.isFn)(loaded)) {
    loaded(d, moduleState);
  }

  if ((0, _util.isFn)(initState)) {
    Promise.resolve().then(function () {
      return initState(moduleState);
    }).then(function (state) {
      (0, _handlerFactory.makeSetStateHandler)(moduleName, initStateDone)(state);
    })["catch"](_ccContext["default"].runtimeHandler.tryHandleError);
  } else {
    // make sure initStateDone will be alway called no matther initState difined or not
    (0, _util.isFn)(initStateDone) && initStateDone(d, moduleState);
  }
}