"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _ccContext = _interopRequireDefault(require("../../cc-context"));

var _getFeatureStr = _interopRequireDefault(require("./get-feature-str"));

var _getCcClasskey = _interopRequireDefault(require("../param/get-cc-classkey"));

var _getRdkeyClasses = _interopRequireDefault(require("../param/get-rdkey-classes"));

var checker = _interopRequireWildcard(require("../param/checker"));

var ex = _interopRequireWildcard(require("../param/extractor"));

var util = _interopRequireWildcard(require("../../support/util"));

var _constant = require("../../support/constant");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var ccClassKey2Context = _ccContext["default"].ccClassKey2Context;

function checkCcStartupOrNot() {
  if (_ccContext["default"].isStartup !== true) {
    throw new Error('you must call run api to startup concent before register Class!');
  }
}
/**
 * map registration info to ccContext
 */


function mapRegInfo(module, ccClassKey, regRenderKeyClasses, classKeyPrefix, regWatchedKeys, regConnect, __checkStartUp, __calledBy) {
  if (module === void 0) {
    module = _constant.MODULE_DEFAULT;
  }

  if (__checkStartUp === true) checkCcStartupOrNot();
  var allowNamingDispatcher = __calledBy === 'cc';
  var renderKeyClasses = regRenderKeyClasses || [];
  checker.checkModuleName(module, false, "module[" + module + "] not configured");
  checker.checkRenderKeyClasses(renderKeyClasses);

  var _connect = ex.getConnect(regConnect);

  var _watchedKeys = ex.getWatchedStateKeys(module, ccClassKey, regWatchedKeys); // 注意此处用户不指定renderKeyClasses时，算出来的特征值和renderKeyClasses无关


  var featureStr = (0, _getFeatureStr["default"])(module, _connect, renderKeyClasses);

  var _ccClassKey = (0, _getCcClasskey["default"])(allowNamingDispatcher, module, _connect, classKeyPrefix, featureStr, ccClassKey); // 此处再次获得真正的renderKeyClasses


  var _renderKeyClasses = (0, _getRdkeyClasses["default"])(_ccClassKey, regRenderKeyClasses);

  var ccClassContext = ccClassKey2Context[_ccClassKey]; //做一个判断，有可能是热加载调用

  if (!ccClassContext) {
    ccClassContext = util.makeCcClassContext(module, _ccClassKey, _renderKeyClasses);
    ccClassKey2Context[_ccClassKey] = ccClassContext;
  }

  return {
    _module: module,
    _connect: _connect,
    _ccClassKey: _ccClassKey,
    _watchedKeys: _watchedKeys
  };
}

var _default = mapRegInfo;
exports["default"] = _default;