"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = _default;

var _ccContext = _interopRequireDefault(require("../../cc-context"));

var _constant = require("../../support/constant");

var _buildMockEvent = _interopRequireDefault(require("./build-mock-event"));

var _extractStateByCcsync = _interopRequireDefault(require("../state/extract-state-by-ccsync"));

var _changeRefState = _interopRequireDefault(require("../state/change-ref-state"));

var checker = _interopRequireWildcard(require("../param/checker"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var getState = _ccContext["default"].store.getState;

function _default(spec, ref, e) {
  var refCtx = ref.ctx;
  var mockE = (0, _buildMockEvent["default"])(spec, e, refCtx);
  if (!mockE) return; // 参数无效 例如 <input onChange={this.sync}/> 导致

  var ccKey = refCtx.ccKey,
      ccUniqueKey = refCtx.ccUniqueKey,
      refModule = refCtx.module;
  var currentTarget = mockE.currentTarget;
  var dataset = currentTarget.dataset,
      value = currentTarget.value,
      extraState = currentTarget.extraState,
      noAutoExtract = currentTarget.noAutoExtract;
  if (e && e.stopPropagation) e.stopPropagation();
  var ccint = dataset.ccint,
      ccdelay = dataset.ccdelay,
      ccrkey = dataset.ccrkey;
  var ccsync = dataset.ccsync;

  if (ccsync.startsWith('/')) {
    ccsync = "" + refModule + ccsync; // 附加上默认模块值
  }

  var options = {
    calledBy: _constant.SYNC,
    ccKey: ccKey,
    ccUniqueKey: ccUniqueKey,
    module: refModule,
    renderKey: ccrkey,
    delay: ccdelay
  };

  var doExtract = function doExtract(fullState) {
    return (0, _extractStateByCcsync["default"])(ccsync, value, ccint, fullState, mockE.isToggleBool, refModule);
  };

  if (ccsync.includes('/')) {
    // syncModuleState 同步模块的state状态
    var targetModule = ccsync.split('/')[0];
    checker.checkModuleName(targetModule, false);
    options.module = targetModule;

    if (noAutoExtract) {
      if (extraState) (0, _changeRefState["default"])(extraState, options, ref);
      return;
    }

    var fullState = targetModule !== refModule ? getState(targetModule) : ref.state;

    var _doExtract = doExtract(fullState),
        state = _doExtract.state,
        module = _doExtract.module,
        keys = _doExtract.keys,
        keyPath = _doExtract.keyPath;

    Object.assign(options, {
      module: module,
      keys: keys,
      keyPath: keyPath
    });
    (0, _changeRefState["default"])(state, options, ref);
  } else {
    // 调用自己的setState句柄触发更新，key可能属于local的，也可能属于module的
    if (noAutoExtract) {
      if (extraState) ref.setState(extraState, null, options);
      return;
    }

    var _doExtract2 = doExtract(ref.state),
        _state = _doExtract2.state,
        _module = _doExtract2.module,
        _keys = _doExtract2.keys,
        _keyPath = _doExtract2.keyPath;

    Object.assign(options, {
      module: _module,
      keys: _keys,
      keyPath: _keyPath
    });
    ref.setState(_state, null, options);
  }
}