"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = _default;

var _ccContext = _interopRequireDefault(require("../../cc-context"));

var util = _interopRequireWildcard(require("../../support/util"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var moduleName2stateKeys = _ccContext["default"].moduleName2stateKeys,
    _ccContext$store = _ccContext["default"].store,
    getPrevState = _ccContext$store.getPrevState,
    getState = _ccContext$store.getState,
    getStateVer = _ccContext$store.getStateVer;

var warn = function warn(key, frag) {
  return util.justWarning("effect: key[" + key + "] is invalid, its " + frag + " has not been declared in' store!");
};

function mapSettedList(settedList) {
  return settedList.reduce(function (map, _ref) {
    var module = _ref.module,
        keys = _ref.keys;
    keys.forEach(function (key) {
      return map[module + "/" + key] = 1;
    });
    return map;
  }, {});
}

function _default(ref, callByDidMount) {
  var ctx = ref.ctx;
  var _ctx$effectMeta = ctx.effectMeta,
      effectItems = _ctx$effectMeta.effectItems,
      eid2effectReturnCb = _ctx$effectMeta.eid2effectReturnCb,
      effectPropsItems = _ctx$effectMeta.effectPropsItems,
      eid2effectPropsReturnCb = _ctx$effectMeta.eid2effectPropsReturnCb;
  var __$$prevMoStateVer = ctx.__$$prevMoStateVer,
      __$$settedList = ctx.__$$settedList,
      refModule = ctx.module;

  var makeItemHandler = function makeItemHandler(eid2cleanCb, isFirstCall, needJudgeImmediate) {
    return function (item) {
      var fn = item.fn,
          eId = item.eId,
          immediate = item.immediate;

      if (needJudgeImmediate) {
        if (immediate === false) return;
      }

      var prevCb = eid2cleanCb[eId];
      if (prevCb) prevCb(ctx); // let ctx.effect have the totally same behavior with useEffect

      var cb = fn(ctx, isFirstCall);
      eid2cleanCb[eId] = cb; //不管有没有返回，都要覆盖之前的结果
    };
  };

  if (callByDidMount) {
    // flag isFirstCall as true
    effectItems.forEach(makeItemHandler(eid2effectReturnCb, true, true));
    effectPropsItems.forEach(makeItemHandler(eid2effectPropsReturnCb, true, true));
    return;
  } // callByDidUpdate
  // start handle effect meta data of state keys


  var prevState = ctx.prevState;
  var curState = ctx.unProxyState;
  var toBeExecutedFns = [];
  effectItems.forEach(function (item) {
    // const { status, depKeys, fn, eId } = item;
    // if (status === EFFECT_STOPPED) return;
    // todo, 优化为effectDep模式, 利用differStateKeys去命中执行函数
    var modDepKeys = item.modDepKeys,
        depKeys = item.depKeys,
        compare = item.compare,
        fn = item.fn,
        eId = item.eId;

    if (!depKeys) {
      return toBeExecutedFns.push({
        fn: fn,
        eId: eId
      });
    }

    var keysLen = modDepKeys.length;
    if (keysLen === 0) return;
    var mappedSettedKey = mapSettedList(__$$settedList);
    var shouldEffectExecute = false;

    for (var i = 0; i < keysLen; i++) {
      var key = modDepKeys[i];

      var _key$split = key.split('/'),
          module = _key$split[0],
          unmoduledKey = _key$split[1];

      var targetCurState = void 0,
          targetPrevState = void 0;

      if (module !== refModule) {
        var _prevState = getPrevState(module);

        var moduleStateVer = getStateVer(module);

        if (__$$prevMoStateVer[unmoduledKey] === moduleStateVer[unmoduledKey]) {
          continue;
        } else {
          __$$prevMoStateVer[unmoduledKey] = moduleStateVer[unmoduledKey];
        }

        if (!_prevState) {
          warn(key, "module[" + module + "]");
          continue;
        }

        if (!moduleName2stateKeys[module].includes(unmoduledKey)) {
          warn(key, "unmoduledKey[" + unmoduledKey + "]");
          continue;
        }

        targetCurState = getState(module);
        targetPrevState = _prevState;
      } else {
        targetCurState = curState;
        targetPrevState = prevState;
      }

      var isValChanged = targetPrevState[unmoduledKey] !== targetCurState[unmoduledKey];

      if (isValChanged) {
        shouldEffectExecute = true;
      } else {
        // compare为true看有没有发生变化（object类型值不走immutable写法的话，这里是false，所以compare值默认是false）
        // compare为false则看是不是setted
        shouldEffectExecute = compare ? isValChanged : mappedSettedKey[key];
      }

      if (shouldEffectExecute) {
        break;
      }
    }

    if (shouldEffectExecute) {
      toBeExecutedFns.push({
        fn: fn,
        eId: eId
      });
    }
  }); // flag isFirstCall as false, start to run state effect fns

  toBeExecutedFns.forEach(makeItemHandler(eid2effectReturnCb, false, false)); // start handle effect meta data of props keys

  var prevProps = ctx.prevProps;
  var curProps = ctx.props;
  var toBeExecutedPropFns = [];
  effectPropsItems.forEach(function (item) {
    var depKeys = item.depKeys,
        fn = item.fn,
        eId = item.eId;

    if (!depKeys) {
      return toBeExecutedPropFns.push({
        fn: fn,
        eId: eId
      });
    }

    var keysLen = depKeys.length;
    var shouldEffectExecute = false;

    for (var i = 0; i < keysLen; i++) {
      var key = depKeys[i];

      if (prevProps[key] !== curProps[key]) {
        shouldEffectExecute = true;
        break;
      }
    }

    if (shouldEffectExecute) toBeExecutedPropFns.push({
      fn: fn,
      eId: eId
    });
  }); // flag isFirstCall as false, start to run prop effect fns

  toBeExecutedPropFns.forEach(makeItemHandler(eid2effectPropsReturnCb, false, false)); // clear settedList

  __$$settedList.length = 0;
}