"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = executeCuInfo;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _util = require("../../support/util");

var cst = _interopRequireWildcard(require("../../support/constant"));

var waKeyMap = _interopRequireWildcard(require("../../cc-context/wakey-ukey-map"));

var _internalVars = require("../../cc-context/internal-vars");

var _runtimeHandler = _interopRequireDefault(require("../../cc-context/runtime-handler"));

var _index = require("../plugin/index");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/* eslint-disable */
var waKey2uKeyMap = waKeyMap.waKey2uKeyMap,
    waKey2staticUKeyMap = waKeyMap.waKey2staticUKeyMap;

function triggerReRender(ref) {
  if (!ref) return; // 对于挂载好了还未卸载的实例，才有必要触发重渲染

  if (ref.__$$ms === cst.MOUNTED) {
    var refCtx = ref.ctx;

    refCtx.__$$ccForceUpdate();
  }
}

function executeCuInfo(_x) {
  return _executeCuInfo.apply(this, arguments);
}

function _executeCuInfo() {
  _executeCuInfo = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(cuInfo) {
    var fns, len, sourceType, ref, module, fnAsync, fnRetKeys, cuRetContainer, retKey2stateKeys, isModule, stateKeys, curRetKey, i, fn, isAsync, retKey, ret, toSend, uKeyMap, uKeys;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            fns = cuInfo.fns;
            len = fns.length;

            if (!(len === 0)) {
              _context.next = 5;
              break;
            }

            return _context.abrupt("return");

          case 5:
            _context.next = 7;
            return (0, _util.delay)();

          case 7:
            sourceType = cuInfo.sourceType, ref = cuInfo.ref, module = cuInfo.module, fnAsync = cuInfo.fnAsync, fnRetKeys = cuInfo.fnRetKeys, cuRetContainer = cuInfo.cuRetContainer, retKey2stateKeys = cuInfo.retKey2stateKeys;
            isModule = sourceType !== cst.CATE_REF;
            stateKeys = [];
            curRetKey = '';
            _context.prev = 11;
            (0, _index.send)(cst.SIG_ASYNC_COMPUTED_BATCH_START, {
              module: module
            });
            i = 0;

          case 14:
            if (!(i < len)) {
              _context.next = 34;
              break;
            }

            fn = fns[i];
            isAsync = fnAsync[i];
            retKey = fnRetKeys[i];
            curRetKey = retKey;
            ret = void 0;
            (0, _index.send)(cst.SIG_ASYNC_COMPUTED_START, {
              module: module,
              retKey: retKey
            });

            if (!isAsync) {
              _context.next = 27;
              break;
            }

            _context.next = 24;
            return fn();

          case 24:
            ret = _context.sent;
            _context.next = 28;
            break;

          case 27:
            ret = fn();

          case 28:
            cuRetContainer[retKey] = (0, _util.makeCuPackedValue)(false, ret);
            (0, _index.send)(cst.SIG_ASYNC_COMPUTED_END, {
              module: module,
              retKey: retKey
            });
            if (isModule) stateKeys = stateKeys.concat(retKey2stateKeys[retKey]);

          case 31:
            i++;
            _context.next = 14;
            break;

          case 34:
            (0, _index.send)(cst.SIG_ASYNC_COMPUTED_BATCH_END, {
              module: module
            });
            _context.next = 41;
            break;

          case 37:
            _context.prev = 37;
            _context.t0 = _context["catch"](11);

            if (isModule) {
              toSend = {
                module: module,
                err: _context.t0,
                retKey: curRetKey
              };
              (0, _index.send)(cst.SIG_ASYNC_COMPUTED_ERR, toSend);
              (0, _index.send)(cst.SIG_ASYNC_COMPUTED_BATCH_END, toSend);
            }

            _runtimeHandler["default"].tryHandleError(_context.t0);

          case 41:
            if (isModule) {
              //  让所有正确执行完毕的计算函数关联到的实例能够被触发重渲染
              stateKeys = Array.from(new Set(stateKeys));
              uKeyMap = {};
              stateKeys.forEach(function (stateKey) {
                var waKey = module + "/" + stateKey; // 利用assign不停的去重

                Object.assign(uKeyMap, waKey2uKeyMap[waKey], waKey2staticUKeyMap[waKey]);
              });
              uKeys = (0, _util.okeys)(uKeyMap);
              uKeys.forEach(function (refKey) {
                triggerReRender(_internalVars.refs[refKey]);
              });
            } else {
              triggerReRender(ref);
            }

            _context.next = 47;
            break;

          case 44:
            _context.prev = 44;
            _context.t1 = _context["catch"](0);

            _runtimeHandler["default"].tryHandleError(_context.t1);

          case 47:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[0, 44], [11, 37]]);
  }));
  return _executeCuInfo.apply(this, arguments);
}