"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = _default;

var _ccContext = _interopRequireDefault(require("../../cc-context"));

var util = _interopRequireWildcard(require("../../support/util"));

var _privConstant = require("../../support/priv-constant");

var _constant = require("../../support/constant");

var _configureDepFns = _interopRequireDefault(require("../base/configure-dep-fns"));

var _findDepFnsToExecute = _interopRequireDefault(require("../base/find-dep-fns-to-execute"));

var _pickDepFns = _interopRequireDefault(require("../base/pick-dep-fns"));

var _makeCuRetContainer = _interopRequireDefault(require("../computed/make-cu-ret-container"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var isPJO = util.isPJO;

function _default(module, computed) {
  if (computed === void 0) {
    computed = {};
  }

  if (!isPJO(computed)) {
    throw new Error("module[" + module + "] computed " + _privConstant.INAJ);
  }

  var ccComputed = _ccContext["default"].computed;

  var rootState = _ccContext["default"].store.getState();

  var rootComputedValue = ccComputed.getRootComputedValue();
  var rootComputedDep = ccComputed.getRootComputedDep();
  var rootComputedRaw = ccComputed.getRootComputedRaw(); // 在init-module-state那里已safeGet, 这里可以安全的直接读取

  var cuOri = ccComputed._computedRawValues[module];
  rootComputedRaw[module] = computed;
  var moduleState = rootState[module];
  (0, _configureDepFns["default"])(_constant.CATE_MODULE, {
    type: _constant.FN_CU,
    module: module,
    stateKeys: util.okeys(moduleState),
    dep: rootComputedDep
  }, computed);

  var d = _ccContext["default"].getDispatcher();

  var curDepComputedFns = function curDepComputedFns(committedState, isBeforeMount) {
    return (0, _pickDepFns["default"])(isBeforeMount, _constant.CATE_MODULE, _constant.FN_CU, rootComputedDep, module, moduleState, committedState);
  };

  rootComputedValue[module] = (0, _makeCuRetContainer["default"])(computed, cuOri);
  var moduleComputedValue = rootComputedValue[module];

  try {
    (0, _findDepFnsToExecute["default"])(d, module, d && d.ctx.module, moduleState, curDepComputedFns, moduleState, moduleState, moduleState, util.makeCallInfo(module), true, _constant.FN_CU, _constant.CATE_MODULE, moduleComputedValue);
  } catch (err) {
    _ccContext["default"].runtimeHandler.tryHandleError(err);
  }
}