"use strict";

exports.__esModule = true;
exports["default"] = _default;
exports.recordFirst2HookCallLoc = recordFirst2HookCallLoc;
var isStrictMode = false;
var locMsgs = {
  1: '',
  2: ''
};

function isLocEqual() {
  var mark = 'atbeginWork';
  var locStr1 = locMsgs[1].replace(/ /g, '');
  var locStr2 = locMsgs[2].replace(/ /g, ''); // 来自 react 18 影响，此处需要优化为更严格的判断
  // 截掉中间影响判断的一段，以 atbeginWork 为标记，向左找到第二个分号位置，作为截取参数
  // react-dom.development.js:20909:19)\natbeginWork
  // react-dom.development.js:20838:13)\natbeginWork

  var find2ndSemicolonIdx = function find2ndSemicolonIdx(str, startIndex) {
    var targetIdx = startIndex;
    var semicolonCount = 0;

    for (var tmpIdx = startIndex; tmpIdx >= 0; tmpIdx--) {
      var _char = str[tmpIdx];

      if (_char === ':') {
        semicolonCount++;
      }

      if (semicolonCount === 2) {
        targetIdx = tmpIdx;
        break;
      }
    }

    return targetIdx;
  };

  var markIdx1 = locStr1.indexOf(mark);

  if (markIdx1 === -1) {
    // 非 react 18 版本或线上已编译版本
    return false;
  }

  var markIdx2 = locStr2.indexOf(mark);
  var semi1 = find2ndSemicolonIdx(locStr1, markIdx1);
  var semi2 = find2ndSemicolonIdx(locStr2, markIdx2);
  var newLocStr1 = "" + locStr1.substring(0, semi1) + locStr1.substring(markIdx1);
  var newLocStr2 = "" + locStr2.substring(0, semi2) + locStr2.substring(markIdx2);
  return newLocStr1 === newLocStr2;
}

function recordFirst2HookCallLoc(cursor, msg) {
  locMsgs[cursor] = msg;

  if (cursor === 2 && isLocEqual()) {
    isStrictMode = true;
  }
}

function _default() {
  return isStrictMode;
}