"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.getConnect = getConnect;
exports.getStoredKeys = getStoredKeys;
exports.getWatchedStateKeys = getWatchedStateKeys;

var _constant = require("../../support/constant");

var _privConstant = require("../../support/priv-constant");

var util = _interopRequireWildcard(require("../../support/util"));

var _ccContext = _interopRequireDefault(require("../../cc-context"));

var checker = _interopRequireWildcard(require("./checker"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var getModuleStateKeys = _ccContext["default"].getModuleStateKeys;
var verifyKeys = util.verifyKeys,
    vbi = util.verboseInfo,
    okeys = util.okeys;

function getStoredKeys(belongMotule, refPrivState, ccOptionStoredKeys, regStoredKeys) {
  var targetStoredKeys = ccOptionStoredKeys || regStoredKeys;

  if (!targetStoredKeys) {
    return [];
  }

  var moduleStateKeys = getModuleStateKeys(belongMotule);

  if (targetStoredKeys === '*') {
    // refPrivState里可能含有moduleStateKey，需要进一步过滤
    return okeys(refPrivState).filter(function (k) {
      return !moduleStateKeys.includes(k);
    });
  } else {
    checker.checkStoredKeys(belongMotule, targetStoredKeys);
    return targetStoredKeys;
  }
}

function getWatchedStateKeys(module, ccClassKey, regWatchedKeys) {
  if (ccClassKey === _constant.CC_DISPATCHER) return [];
  if (!regWatchedKeys) return [];

  if (regWatchedKeys === '*') {
    return getModuleStateKeys(module);
  }

  if (regWatchedKeys === '-') {
    return regWatchedKeys;
  }

  var _verifyKeys = verifyKeys(regWatchedKeys, []),
      notArray = _verifyKeys.notArray,
      keyElementNotString = _verifyKeys.keyElementNotString;

  if (notArray || keyElementNotString) {
    var vbiInfo = vbi("ccClassKey:" + ccClassKey);
    throw new Error("watchedKeys " + _privConstant.STR_ARR_OR_STAR + " " + vbiInfo);
  }

  return regWatchedKeys;
}

function getConnect(regConnect) {
  var targetConnect = regConnect || {}; // codesandbox lost default value

  if (!util.isPJO(targetConnect, true)) {
    throw new Error("param connect type error, it " + _privConstant.INAJ + " or string array");
  }

  var isArr = Array.isArray(targetConnect);
  var finalConnect = {};

  if (isArr || typeof targetConnect === 'string') {
    var connectedModules = isArr ? targetConnect : targetConnect.split(',');
    connectedModules.forEach(function (m) {
      finalConnect[m] = '-'; //标识自动收集观察依赖
    });
  } else {
    finalConnect = regConnect;
  } // 未设定连接$$global模块的watchedKeys参数时，自动连接$$global模块，并默认采用依赖收集


  if (!finalConnect[_constant.MODULE_GLOBAL]) {
    finalConnect[_constant.MODULE_GLOBAL] = '-';
  }

  checker.checkConnectSpec(finalConnect);
  return finalConnect;
}