"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = _default;

var _ccContext = _interopRequireDefault(require("../../cc-context"));

var _constant = require("../../support/constant");

var util = _interopRequireWildcard(require("../../support/util"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var isObjectNull = util.isObjectNull,
    me = util.makeError;
var featureStr2classKey = _ccContext["default"].featureStr2classKey,
    userClassKey2featureStr = _ccContext["default"].userClassKey2featureStr,
    ccClassKey2Context = _ccContext["default"].ccClassKey2Context;
var cursor = 0;

function _default(allowNamingDispatcher, module, connect, prefix, featureStr, classKey) {
  if (classKey === void 0) {
    classKey = '';
  }

  // 未指定classKey
  if (!classKey) {
    // 未指定所属模块，也未连接到其他模块
    if (module === _constant.MODULE_DEFAULT && isObjectNull(connect)) {
      return prefix + "0";
    }

    var prefixedFeatureStr = prefix + ":" + featureStr;
    var _classKey = featureStr2classKey[prefixedFeatureStr];

    if (_classKey) {
      return _classKey;
    }

    cursor++;
    _classKey = "" + prefix + cursor;
    featureStr2classKey[prefixedFeatureStr] = _classKey;
    return _classKey;
  } // verify user input classKey


  if (classKey.startsWith(_constant.CC_PREFIX)) {
    throw new Error("user can not specify a classKey[" + classKey + "] starts with $$Cc");
  }

  if (!allowNamingDispatcher) {
    if (classKey.toLowerCase() === _constant.CC_DISPATCHER.toLowerCase()) {
      // throw new Error(`${CC_DISPATCHER} is cc built-in ccClassKey name, if you want to customize your dispatcher, 
      // you can set autoCreateDispatcher=false in StartupOption, and use createDispatcher then.`)
      // currently createDispatcher is not allowed..
      throw new Error(_constant.CC_DISPATCHER + " is cc built-in ccClassKey name.");
    }
  }

  var clsCtx = ccClassKey2Context[classKey];

  if (clsCtx) {
    var fStr = userClassKey2featureStr[classKey];

    if (fStr !== featureStr) {
      // 不允许，特征值不一样的class指定相同的ccClassKey
      throw me(_constant.ERR.CC_CLASS_KEY_DUPLICATE, "ccClassKey:[" + classKey + "] duplicate");
    }
  } else {
    userClassKey2featureStr[classKey] = featureStr;
  }

  return classKey;
}