"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = _default;

var _ccContext = _interopRequireDefault(require("../../cc-context"));

var util = _interopRequireWildcard(require("../../support/util"));

var _privConstant = require("../../support/priv-constant");

var _dispatch = _interopRequireDefault(require("../../api/dispatch"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function attachFnInfo(moduleName, fnName, wrappedFn, reducerFn) {
  // 给函数绑上模块名，方便dispatch可以直接调用函数时，也能知道是更新哪个模块的数据，
  wrappedFn.__stateModule = moduleName;
  wrappedFn.__fnName = fnName; // !!! 很重要，将真正的名字附记录上，否则名字是编译后的缩写名
  // AsyncFunction GeneratorFunction Function

  wrappedFn.__ctName = reducerFn.__ctName || reducerFn.constructor.name;
  wrappedFn.__isAsync = util.isAsyncFn(reducerFn);
}

function _default(module, reducer, ghosts) {
  if (reducer === void 0) {
    reducer = {};
  }

  if (ghosts === void 0) {
    ghosts = [];
  }

  if (!util.isPJO(reducer)) {
    throw new Error("module[" + module + "] reducer " + _privConstant.INAJ);
  }

  var _ccContext$reducer = _ccContext["default"].reducer,
      _reducer = _ccContext$reducer._reducer,
      _caller = _ccContext$reducer._caller,
      _fnName2fullFnNames = _ccContext$reducer._fnName2fullFnNames,
      _module2fnNames = _ccContext$reducer._module2fnNames,
      _module2Ghosts = _ccContext$reducer._module2Ghosts; // 防止同一个reducer被载入到不同模块时，setState附加逻辑不正确

  var newReducer = Object.assign({}, reducer);
  _reducer[module] = newReducer;
  var subReducerCaller = util.safeGet(_caller, module); // const subReducerRefCaller = util.safeGet(_reducerRefCaller, module);

  var fnNames = util.safeGetArray(_module2fnNames, module);
  util.safeGet(_module2Ghosts, module, ghosts.slice());
  ghosts.forEach(function (ghostFnName) {
    if (!reducer[ghostFnName]) throw new Error("ghost[" + ghostFnName + "] not exist");
  }); // 自动附加一个setState在reducer里

  if (!newReducer.setState) {
    var injectedSetState = function injectedSetState(payload) {
      return payload;
    };

    attachFnInfo(module, 'setState', injectedSetState, injectedSetState);
    newReducer.setState = injectedSetState;
  }

  var reducerFnNames = util.okeys(newReducer);
  reducerFnNames.forEach(function (name) {
    // avoid hot reload
    util.noDupPush(fnNames, name);
    var fullFnName = module + "/" + name;
    var list = util.safeGetArray(_fnName2fullFnNames, name); // avoid hot reload

    util.noDupPush(list, fullFnName);

    subReducerCaller[name] = function (payload, renderKeyOrOptions, delay) {
      return (0, _dispatch["default"])(fullFnName, payload, renderKeyOrOptions, delay);
    };

    var reducerFn = newReducer[name];

    if (!util.isFn(reducerFn)) {
      throw new Error("module[" + module + "] reducer[" + name + "] " + _privConstant.INAF);
    } else {
      var targetFn = reducerFn;

      if (reducerFn.__fnName) {
        // 将某个已载入到模块a的reducer再次载入到模块b
        targetFn = function targetFn(payload, moduleState, actionCtx) {
          return reducerFn(payload, moduleState, actionCtx);
        };

        newReducer[name] = targetFn;
      }

      attachFnInfo(module, name, targetFn, reducerFn);
    }
  });
}