"use strict";

exports.__esModule = true;
exports.createModuleNode = createModuleNode;
exports.getCache = getCache;
exports.getCacheKey = getCacheKey;
exports.setCache = setCache;
var key2findResult = {};

function createModuleNode(moduleName) {
  key2findResult[moduleName] = {};
}

function getCacheKey(moduleName, sharedStateKeys, renderKeys, renderKeyClasses) {
  if (renderKeyClasses === void 0) {
    renderKeyClasses = [];
  }

  var renderKeyStr = renderKeys ? renderKeys.join(',') : '';
  var featureStr1 = sharedStateKeys.sort().join(',');
  var featureStr2 = renderKeyClasses === '*' ? '*' : renderKeyClasses.sort().join(',');
  return moduleName + "/" + featureStr1 + "/" + renderKeyStr + "/" + featureStr2;
}

function getCache(moduleName, key) {
  return key2findResult[moduleName][key];
}

function setCache(moduleName, key, result) {
  key2findResult[moduleName][key] = result;
}