"use strict";

exports.__esModule = true;
exports["default"] = _default;

var _privConstant = require("../../support/priv-constant");

var _util = require("../../support/util");

var cache = _interopRequireWildcard(require("./_cache"));

var _wakeyUkeyMap = require("../../cc-context/wakey-ukey-map");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

// before render
// cur: {} compare: {a:2, b:2, c:2} compareCount=3 nextCompare:{}
//
// rendering input
// cur: {a:'val', c:'val', d:'val'}
//
// after render
// cur: {a:1, c:1, c:1} compare: {a:1, b:2, c:1, d:1} nextCompare:{a:2, c:2, d:2}
//
// then concent will know b should delete dep because=0, 
// compare key count=4>3 or compare include 2, so should let cache expire
//
// before next render
// cur: {} compare: {a:2, c:2, d:2} compareCount=3 nextCompare:{}

/** 删除依赖 */
function delDep(compareWaKeys, compareWaKeyCount, module, ccUniqueKey) {
  var waKeys = (0, _util.okeys)(compareWaKeys);
  var waKeyKen = waKeys.length;
  if (waKeyKen === 0) return;
  var shouldLetCacheExpire = false;
  waKeys.forEach(function (waKey) {
    // no module prefix
    if (compareWaKeys[waKey] === 2) {
      // 这个key在这轮渲染结束后没有命中，说明视图不再对它有依赖
      shouldLetCacheExpire = true;
      (0, _wakeyUkeyMap.delIns)(module, waKey, ccUniqueKey);
    }
  });

  if (waKeys.length > compareWaKeyCount) {
    // 大于最初记录的key数量，有新增
    shouldLetCacheExpire = true;
  } // let find result cache expire


  if (shouldLetCacheExpire) {
    cache.createModuleNode(module);
  }
}

function _default(ref) {
  var ctx = ref.ctx;
  ctx.__$$renderStatus = _privConstant.END;
  var refModule = ctx.module,
      connectedModules = ctx.connectedModules,
      connect = ctx.connect,
      ccUniqueKey = ctx.ccUniqueKey,
      __$$compareWaKeys = ctx.__$$compareWaKeys,
      __$$compareWaKeyCount = ctx.__$$compareWaKeyCount,
      __$$compareConnWaKeys = ctx.__$$compareConnWaKeys,
      __$$compareConnWaKeyCount = ctx.__$$compareConnWaKeyCount; // if ref is autoWatch status, should del belong module dep dynamically after every render period

  if (ctx.__$$autoWatch) {
    delDep(__$$compareWaKeys, __$$compareWaKeyCount, refModule, ccUniqueKey);
  }

  connectedModules.forEach(function (m) {
    // if ref is autoWatch status, should del connected module dep dynamically after every render period
    if (connect[m] === '-') {
      var _$$compareWaKeys = __$$compareConnWaKeys[m];
      var _$$compareWaKeyCount = __$$compareConnWaKeyCount[m];
      delDep(_$$compareWaKeys, _$$compareWaKeyCount, m, ccUniqueKey);
    }
  });
}