"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _constant = require("../../support/constant");

var _ccContext = _interopRequireDefault(require("../../cc-context"));

var _wakeyUkeyMap = require("../../cc-context/wakey-ukey-map");

var util = _interopRequireWildcard(require("../../support/util"));

var _privConstant = require("../../support/priv-constant");

var ev = _interopRequireWildcard(require("../event"));

var hf = _interopRequireWildcard(require("../state/handler-factory"));

var _changeRefState = _interopRequireDefault(require("../state/change-ref-state"));

var _makeObState = _interopRequireDefault(require("../state/make-ob-state"));

var _getDefineWatchHandler = _interopRequireDefault(require("../watch/get-define-watch-handler"));

var _getDefineComputedHandler = _interopRequireDefault(require("../computed/get-define-computed-handler"));

var _makeCuRefObContainer = _interopRequireDefault(require("../computed/make-cu-ref-ob-container"));

var _computeCcUniqueKey = _interopRequireDefault(require("../base/compute-cc-unique-key"));

var _getOutProps = _interopRequireDefault(require("../base/get-out-props"));

var _sync3 = _interopRequireDefault(require("../base/sync"));

var _extractor = require("../param/extractor");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/** @typedef {import('../../types-inner').IRefCtx} ICtx */
var _ccContext$reducer = _ccContext["default"].reducer,
    _caller = _ccContext$reducer._caller,
    _module2fnNames = _ccContext$reducer._module2fnNames,
    _module2Ghosts = _ccContext$reducer._module2Ghosts,
    refStore = _ccContext["default"].refStore,
    getModuleStateKeys = _ccContext["default"].getModuleStateKeys,
    _ccContext$store = _ccContext["default"].store,
    getState = _ccContext$store.getState,
    getModuleVer = _ccContext$store.getModuleVer;
var noop = util.noop;
var okeys = util.okeys,
    me = util.makeError,
    vbi = util.verboseInfo,
    isObject = util.isObject,
    isBool = util.isBool,
    justWarning = util.justWarning,
    isObjectNull = util.isObjectNull,
    isValueNotNull = util.isValueNotNull,
    noDupPush = util.noDupPush;
var idSeq = 0;

function getEId() {
  idSeq += 1;
  return Symbol("__autoGen_" + idSeq + "__");
}

var fnKey = 0;

function getFnKey() {
  fnKey += 1;
  return "" + fnKey;
}

var eType = function eType(th) {
  return "type of defineEffect " + th + " param must be";
};

var getWatchedKeys = function getWatchedKeys(ctx) {
  if (ctx.watchedKeys === '-') {
    if (ctx.__$$renderStatus === _privConstant.START) return okeys(ctx.__$$compareWaKeys);
    return okeys(ctx.__$$curWaKeys);
  }

  return ctx.watchedKeys;
};

var getConnectWatchedKeys = function getConnectWatchedKeys(ctx, moduleName) {
  var connect = ctx.connect,
      connectedModules = ctx.connectedModules;
  var isConnectArr = Array.isArray(connect);

  var getModuleWaKeys = function getModuleWaKeys(m) {
    if (ctx.__$$renderStatus === _privConstant.START) return okeys(ctx.__$$compareConnWaKeys[m]);
    return okeys(ctx.__$$curConnWaKeys[m]);
  };

  var getWKeys = function getWKeys(moduleName) {
    if (isConnectArr) {
      // auto observe connect modules
      return getModuleWaKeys(moduleName);
    } else {
      var waKeys = connect[moduleName];
      if (waKeys === '*') return getModuleStateKeys(moduleName);else if (waKeys === '-') return getModuleWaKeys(moduleName);else return waKeys;
    }
  };

  if (moduleName) return getWKeys(moduleName);else {
    var cKeys = {};
    connectedModules.forEach(function (m) {
      cKeys[m] = getWKeys(m);
    });
    return cKeys;
  }
};

function recordDep(ccUniqueKey, moduleName, watchedKeys) {
  var waKeys = watchedKeys === '*' ? getModuleStateKeys(moduleName) : watchedKeys;
  waKeys.forEach(function (stateKey) {
    return (0, _wakeyUkeyMap.mapIns)(moduleName, stateKey, ccUniqueKey);
  });
}

function makeProxyReducer(m, dispatch, reducerFnType, ghostFnName) {
  if (reducerFnType === void 0) {
    reducerFnType = 0;
  }

  // 让绑定到组件上的mr.{xxx} 方法始终指向同一个，让 memo 优化可以生效
  var name2wrapFn = {}; // 此处代理对象仅用于log时可以打印出目标模块reducer函数集合

  return new Proxy(_caller[m] || {}, {
    get: function get(target, fnName) {
      var fnNames = _module2fnNames[m];

      if (fnNames.includes(fnName)) {
        var _fnKey = m + "/" + fnName;

        var wrapFn = name2wrapFn[_fnKey];

        if (!wrapFn) {
          wrapFn = function wrapFn(payload, renderKey, delay) {
            var callerParams = {
              module: m,
              fnName: fnName,
              payload: payload,
              renderKey: renderKey,
              delay: delay
            };
            if (reducerFnType === 0) return dispatch(_fnKey, payload, renderKey, delay);
            if (reducerFnType === 1) return callerParams;

            if (reducerFnType === 2) {
              if (fnName === ghostFnName) return justWarning("the target fn[" + fnName + "] can't be a ghost");
              return dispatch(m + "/" + ghostFnName, callerParams, renderKey, delay);
            }
          };

          name2wrapFn[_fnKey] = wrapFn;
        }

        return wrapFn;
      } else {
        // 可能是原型链上的其他方法或属性调用
        return target[fnName];
      }
    }
  });
}

function bindCtxToRef(isCtxNull, ref, ctx) {
  if (isCtxNull) return ref.ctx = ctx; // 适配热加载或者异步渲染里, 需要清理ctx里运行时收集的相关数据，重新分配即可
  // 这里需要把第一次渲染期间已经收集好的依赖再次透传给ref.ctx

  var _ref$ctx = ref.ctx,
      __$$curWaKeys = _ref$ctx.__$$curWaKeys,
      __$$compareWaKeys = _ref$ctx.__$$compareWaKeys,
      __$$compareWaKeyCount = _ref$ctx.__$$compareWaKeyCount,
      __$$nextCompareWaKeys = _ref$ctx.__$$nextCompareWaKeys,
      __$$nextCompareWaKeyCount = _ref$ctx.__$$nextCompareWaKeyCount,
      __$$curConnWaKeys = _ref$ctx.__$$curConnWaKeys,
      __$$compareConnWaKeys = _ref$ctx.__$$compareConnWaKeys,
      __$$compareConnWaKeyCount = _ref$ctx.__$$compareConnWaKeyCount,
      __$$nextCompareConnWaKeys = _ref$ctx.__$$nextCompareConnWaKeys,
      __$$nextCompareConnWaKeyCount = _ref$ctx.__$$nextCompareConnWaKeyCount;
  Object.assign(ref.ctx, ctx, {
    __$$curWaKeys: __$$curWaKeys,
    __$$compareWaKeys: __$$compareWaKeys,
    __$$compareWaKeyCount: __$$compareWaKeyCount,
    __$$nextCompareWaKeys: __$$nextCompareWaKeys,
    __$$nextCompareWaKeyCount: __$$nextCompareWaKeyCount,
    __$$curConnWaKeys: __$$curConnWaKeys,
    __$$compareConnWaKeys: __$$compareConnWaKeys,
    __$$compareConnWaKeyCount: __$$compareConnWaKeyCount,
    __$$nextCompareConnWaKeys: __$$nextCompareConnWaKeys,
    __$$nextCompareConnWaKeyCount: __$$nextCompareConnWaKeyCount
  });
}

function bindInitStateHandler(ref, ctx, registryState, refStoredState, mstate, modStateKeys) {
  // allow user have a chance to define state in setup block
  ctx.initState = function (initialStateOrCb) {
    var initialState = initialStateOrCb;

    if (util.isFn(initialStateOrCb)) {
      initialState = initialStateOrCb();
    }

    if (!ctx.__$$inBM) {
      return justWarning("initState must been called in setup block!");
    }

    if (!util.isPJO(registryState)) {
      return justWarning("state " + _privConstant.INAJ);
    }

    if (ctx.__$$cuOrWaCalled) {
      return justWarning("initState must been called before computed or watch");
    }

    var newRefState = Object.assign({}, registryState, initialState, refStoredState, mstate); // 更新stateKeys，防止遗漏新的私有stateKey

    ctx.stateKeys = okeys(newRefState);
    ctx.privStateKeys = util.removeArrElements(okeys(newRefState), modStateKeys);
    ctx.prevState = Object.assign({}, newRefState);
    ctx.unProxyState = newRefState;
    ref.state = Object.assign(ctx.state, newRefState); // 扩展私有属性后，type.d.ts里会自动计算新的fullState，
    // 这里直接返回ctx, 但类型文件仅描述了可解构使用的有 state、setState、computed、watch 四个属性
    // 导出这四个属性可方便直接使用推导出的合并类型

    return ctx;
  };
}

function bindModApis(ref, ctx, stateModule, liteLevel, setState) {
  // 创建dispatch需要ref.ctx里的ccClassKey相关信息, 所以这里放在ref.ctx赋值之后在调用makeDispatchHandler
  var dispatch = hf.makeDispatchHandler(ref, false, false, stateModule);
  ctx.dispatch = dispatch;

  if (liteLevel > 1) {
    // level 2, assign these mod data api
    ctx.lazyDispatch = hf.makeDispatchHandler(ref, true, false, stateModule);
    ctx.silentDispatch = hf.makeDispatchHandler(ref, false, true, stateModule);
    ctx.dispatchLazy = ctx.lazyDispatch; // alias of lazyDispatch

    ctx.dispatchSilent = ctx.silentDispatch; // alias of silentDispatch

    ctx.invoke = hf.makeInvokeHandler(ref);
    ctx.lazyInvoke = hf.makeInvokeHandler(ref, {
      isLazy: true
    });
    ctx.silentInvoke = hf.makeInvokeHandler(ref, {
      isLazy: false,
      isSilent: true
    });
    ctx.invokeLazy = ctx.lazyInvoke; // alias of lazyInvoke

    ctx.invokeSilent = ctx.silentInvoke; // alias of silentInvoke

    ctx.setGlobalState = function (state, reactCallback, renderKey, delay) {
      setState(_constant.MODULE_GLOBAL, state, _constant.SET_STATE, reactCallback, renderKey, delay);
    };
  }

  return dispatch;
}

function bindSyncApis(ref, ctx, liteLevel) {
  if (liteLevel > 2) {
    // level 3, assign sync api
    var cachedBoundFns = {};

    var doSync = function doSync(type, e, val, rkey, delay) {
      if (typeof e === 'string') {
        var valType = typeof val; // now val is syncCb

        if (isValueNotNull(val) && (valType === _privConstant.OBJ || valType === _privConstant.FN || val === _constant.AUTO_VAL)) {
          var _sync$bind;

          return _sync3["default"].bind(null, (_sync$bind = {}, _sync$bind[_constant.CCSYNC_KEY] = e, _sync$bind.type = type, _sync$bind.val = val, _sync$bind.delay = delay, _sync$bind.rkey = rkey, _sync$bind), ref);
        }

        var valStr = val && val.toString ? val.toString() : '';
        var key = e + "|" + valStr + "|" + rkey + "|" + delay;
        var boundFn = cachedBoundFns[key];

        if (!boundFn) {
          var _sync$bind2;

          cachedBoundFns[key] = _sync3["default"].bind(null, (_sync$bind2 = {}, _sync$bind2[_constant.CCSYNC_KEY] = e, _sync$bind2.type = type, _sync$bind2.val = val, _sync$bind2.delay = delay, _sync$bind2.rkey = rkey, _sync$bind2), ref);
          boundFn = cachedBoundFns[key];
        }

        return boundFn;
      } // case: <input data-ccsync="foo/f1" onChange={ctx.sync} />


      (0, _sync3["default"])({
        type: 'val'
      }, ref, e);
    }; // syncer series


    var makeTrap = function makeTrap(type) {
      return {
        get: function get(target, key) {
          if (util.isKeyValid(target, key)) return doSync(type, key);
          return noop;
        }
      };
    };

    ctx.syncer = new Proxy(ctx.state, makeTrap('val'));
    ctx.syncerOfBool = new Proxy(ctx.state, makeTrap('bool'));
    ctx.sybo = ctx.syncerOfBool; // alias of syncerOfBool
    // sync series

    ctx.sync = function (e, val, rkey, delay) {
      if (rkey === void 0) {
        rkey = '';
      }

      if (delay === void 0) {
        delay = -1;
      }

      return doSync('val', e, val, rkey, delay);
    };

    ctx.syncBool = function (e, val, rkey, delay) {
      if (rkey === void 0) {
        rkey = '';
      }

      if (delay === void 0) {
        delay = -1;
      }

      return doSync('bool', e, val, rkey, delay);
    };

    ctx.syncInt = function (e, val, rkey, delay) {
      if (rkey === void 0) {
        rkey = '';
      }

      if (delay === void 0) {
        delay = -1;
      }

      return doSync('int', e, val, rkey, delay);
    };

    ctx.syncAs = function (e, val, rkey, delay) {
      if (rkey === void 0) {
        rkey = '';
      }

      if (delay === void 0) {
        delay = -1;
      }

      return doSync('as', e, val, rkey, delay);
    };

    ctx.set = function (ccsync, val, rkey, delay) {
      var _sync;

      if (rkey === void 0) {
        rkey = '';
      }

      if (delay === void 0) {
        delay = -1;
      }

      (0, _sync3["default"])((_sync = {}, _sync[_constant.CCSYNC_KEY] = ccsync, _sync.type = 'val', _sync.val = val, _sync.delay = delay, _sync.rkey = rkey, _sync), ref);
    };

    ctx.setBool = function (ccsync, rkey, delay) {
      var _sync2;

      if (rkey === void 0) {
        rkey = '';
      }

      if (delay === void 0) {
        delay = -1;
      }

      (0, _sync3["default"])((_sync2 = {}, _sync2[_constant.CCSYNC_KEY] = ccsync, _sync2.type = 'bool', _sync2.delay = delay, _sync2.rkey = rkey, _sync2), ref);
    };
  }
}

function bindEventApis(ctx, liteLevel, ccUniqueKey) {
  if (liteLevel > 3) {
    // level 4, assign event api
    ctx.emit = function (event) {
      for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      ev.findEventHandlersToPerform.apply(ev, [ev.getEventItem(event)].concat(args));
    }; // 默认off掉当前实例对某个事件名的所有监听


    ctx.off = function (event, _temp) {
      var _ref = _temp === void 0 ? {} : _temp,
          module = _ref.module,
          ccClassKey = _ref.ccClassKey,
          _ref$ccUniqueKey = _ref.ccUniqueKey,
          inputCcUkey = _ref$ccUniqueKey === void 0 ? ccUniqueKey : _ref$ccUniqueKey;

      var targetCcUkey = inputCcUkey; // 传递了 module 或者 ccClassKey的话，清理掉targetCcUkey，表示off的目标要扩大

      if (module || ccClassKey) targetCcUkey = ''; // 这里刻意不为identity赋默认值，如果是undefined，表示off掉所有监听

      var _ev$getEventItem = ev.getEventItem(event),
          name = _ev$getEventItem.name,
          identity = _ev$getEventItem.identity;

      ev.findEventHandlersToOff(name, {
        module: module,
        ccClassKey: ccClassKey,
        ccUniqueKey: targetCcUkey,
        identity: identity
      });
    };

    ctx.on = function (inputEvent, handler) {
      ctx.__$$onEvents.push({
        inputEvent: inputEvent,
        handler: handler
      });
    };
  }
}

function _makeCuWaDesc(moduleName, fnKeyOrDesc, cb, cbOptions) {
  var newDesc = {};

  var makeFnDesc = function makeFnDesc(fn, cbOptions) {
    var fnDesc = util.isObject(fn) ? fn : {
      fn: fn
    }; // 因为加上 / 后，cb的state类型会和模块相关了，types文件目前不方便推导含 / 的cb参数类型
    // 所以types文件里不允许传递 allowSlash 标记，让用户定义的retKey包含 / 会报运行时错误
    // 同时额外提供的 watchModule方法和 computedModule 方法需要用到 / 携带模块的特性
    // 故需内部放过不允许key包含slash的校验，所以这里加上 allowSlash 标记

    var opts = {};
    if (cbOptions) opts = util.isObject(cbOptions) ? cbOptions : {
      depKeys: cbOptions
    };
    var depKeys = opts.depKeys || fnDesc.depKeys;

    if (Array.isArray(depKeys)) {
      // 让 watchModule 的 depKeys 不拼模块前缀也能生效
      depKeys = depKeys.map(function (key) {
        return key.includes('/') ? key : moduleName + "/" + key;
      });
    } // 不是自动搜集、也不是全依赖，置为自动收集模式
    else if (!['-', '*'].includes(depKeys)) {
      depKeys = '-';
    }

    return Object.assign({
      allowSlash: true,
      depKeyModule: moduleName
    }, fnDesc, opts, {
      depKeys: depKeys
    });
  };

  if (typeof fnKeyOrDesc === 'string') {
    newDesc[moduleName + "/" + fnKeyOrDesc] = makeFnDesc(cb, cbOptions);
  } else if (util.isObject(fnKeyOrDesc)) {
    util.okeys(fnKeyOrDesc).forEach(function (key) {
      newDesc[moduleName + "/" + key] = makeFnDesc(fnKeyOrDesc[key]);
    });
  }

  return newDesc;
}

function bindEnhanceApis(ctx, liteLevel, stateModule) {
  var effectItems = [],
      effectPropsItems = []; // {fn:function, status:0, eId:'', immediate:true}

  var eid2effectReturnCb = {},
      eid2effectPropsReturnCb = {}; // fn

  ctx.effectMeta = {
    effectItems: effectItems,
    eid2effectReturnCb: eid2effectReturnCb,
    effectPropsItems: effectPropsItems,
    eid2effectPropsReturnCb: eid2effectPropsReturnCb
  };

  if (liteLevel > 4) {
    // level 5, assign enhance api
    ctx.execute = function (handler) {
      return ctx.execute = handler;
    };

    ctx.watch = (0, _getDefineWatchHandler["default"])(ctx);
    ctx.computed = (0, _getDefineComputedHandler["default"])(ctx); // 方便type文件定义类型时能够推导出cb的参数类型为已连接的模块状态类型

    ctx.watchModule = function (moduleName, cbOrMultiWatchDesc, cbOptions) {
      if (cbOptions === void 0) {
        cbOptions = {};
      }

      if (util.isFn(cbOrMultiWatchDesc)) {
        ctx.watch(_makeCuWaDesc(moduleName, getFnKey(), cbOrMultiWatchDesc, cbOptions));
      } else {
        ctx.watch(_makeCuWaDesc(moduleName, cbOrMultiWatchDesc));
      }
    }; // 方便type文件定义类型时能够推导出cb的参数类型为已连接的模块状态类型


    ctx.computedModule = function (moduleName, retKey, cb, cbOptions) {
      return ctx.computed(_makeCuWaDesc(moduleName, retKey, cb, cbOptions));
    };

    var makeEffectHandler = function makeEffectHandler(targetEffectItems, isProp) {
      return function (fn, depKeysOrOpt, compare, immediate) {
        if (immediate === void 0) {
          immediate = true;
        }

        if (!util.isFn(fn)) throw new Error(eType('first') + " function");
        var compareForEf = compare === undefined ? false : compare; // 对于effectProps 第三位参数就是immediate, 不传的话，默认是true

        var immediateForEfProp = compare === undefined ? true : compare; // depKeys 为 null 和 undefined, 表示无任何依赖，每一轮都执行的副作用

        var _depKeys = depKeysOrOpt;
        var _compare = compareForEf;

        var _immediate = isProp ? immediateForEfProp : immediate;

        if (isObject(depKeysOrOpt)) {
          _depKeys = depKeysOrOpt.depKeys;
          _compare = isBool(depKeysOrOpt.compare) ? depKeysOrOpt.compare : compare;
          _immediate = isBool(depKeysOrOpt.immediate) ? depKeysOrOpt.immediate : immediate;
        }

        if (_depKeys !== undefined && _depKeys !== null && !Array.isArray(_depKeys)) {
          throw new Error(eType('second') + " array, null, or undefined");
        }

        var modDepKeys = [];

        if (!isProp && _depKeys) {
          _depKeys.forEach(function (depKey) {
            var modDepKey;

            if (depKey.includes('/')) {
              modDepKey = depKey;

              var _depKey$split = depKey.split('/'),
                  m = _depKey$split[0];

              if (!ctx.connect[m]) {
                throw me(_constant.ERR.CC_MODULE_NOT_CONNECTED, vbi("depKey[" + depKey + "]"));
              }
            } else {
              // 这里要注意， 私有的key
              modDepKey = stateModule + "/" + depKey;
            }

            modDepKeys.push(modDepKey); // 先暂时保持起来，组件挂载时才映射依赖

            ctx.__$$staticWaKeys[modDepKey] = 1;
          });
        } // 对于effectProps来说是不会读取compare属性来用的


        var effectItem = {
          fn: fn,
          isProp: isProp,
          depKeys: _depKeys,
          modDepKeys: modDepKeys,
          eId: getEId(),
          compare: _compare,
          immediate: _immediate
        };
        targetEffectItems.push(effectItem);
      };
    };

    ctx.effect = makeEffectHandler(effectItems, false);
    ctx.effectProps = makeEffectHandler(effectPropsItems, true);
  }
}

function fillCtxOtherAttrs(ref, ctx, connect, watchedKeys, ccUniqueKey, stateModule, allModules, dispatch) {
  // 构造完毕ctx后，开始创建 reducer，和可观察 connectedState
  var connectedReducer = ctx.connectedReducer,
      connectedState = ctx.connectedState,
      __$$curConnWaKeys = ctx.__$$curConnWaKeys,
      __$$compareConnWaKeys = ctx.__$$compareConnWaKeys,
      __$$compareConnWaKeyCount = ctx.__$$compareConnWaKeyCount,
      __$$nextCompareConnWaKeys = ctx.__$$nextCompareConnWaKeys,
      __$$nextCompareConnWaKeyCount = ctx.__$$nextCompareConnWaKeyCount; // 实例所属模块或连接模块是否处于自动观察状态

  var __$$autoWatch = false; // 向实例的reducer里绑定方法，key:{module} value:{reducerFn}
  // 只绑定所属的模块和已连接的模块的reducer方法

  allModules.forEach(function (m) {
    var rd = makeProxyReducer(m, dispatch);

    if (m === stateModule) {
      ctx.moduleReducer = rd;
      ctx.mrc = makeProxyReducer(m, dispatch, 1);
      var ghosts = _module2Ghosts[m] || [];
      ghosts.forEach(function (ghostFnName) {
        ctx.mrg[ghostFnName] = makeProxyReducer(m, dispatch, 2, ghostFnName);
      });
      if (m === _constant.MODULE_GLOBAL) connectedReducer[m] = rd;
    } else {
      connectedReducer[m] = rd;
    }

    var connectDesc = connect[m];

    if (connectDesc) {
      var moduleState = getState(m);

      if (connectDesc === '-') {
        // auto watch
        __$$autoWatch = true;
        __$$curConnWaKeys[m] = {};
        __$$compareConnWaKeys[m] = {};
        __$$compareConnWaKeyCount[m] = 0;
        __$$nextCompareConnWaKeys[m] = {};
        __$$nextCompareConnWaKeyCount[m] = 0;
        if (m === _constant.MODULE_GLOBAL) moduleState = ctx.globalState;else moduleState = (0, _makeObState["default"])(ref, moduleState, m);
      } else {
        // 非自动收集，这里就需要写入waKey2uKeyMap来记录依赖关系了
        recordDep(ccUniqueKey, m, connectDesc);
      }

      connectedState[m] = moduleState;
    }
  });
  ctx.reducer = _caller;
  ctx.globalReducer = connectedReducer[_constant.MODULE_GLOBAL]; // alias

  ctx.mr = ctx.moduleReducer;
  ctx.gr = ctx.globalReducer;
  ctx.cr = ctx.connectedReducer;
  ctx.r = ctx.reducer;

  if (watchedKeys === '-') {
    __$$autoWatch = true;
  } else {
    // 开始记录依赖
    recordDep(ccUniqueKey, stateModule, watchedKeys);
  }

  ctx.__$$autoWatch = __$$autoWatch;
}
/**
 * 构建refCtx，附加到ref上
 * liteLevel 越小，绑定的方法越少
 */


function buildRefCtx(ref, params, liteLevel) {
  if (liteLevel === void 0) {
    liteLevel = 5;
  }

  // 能省赋默认值的就省，比如state，外层调用都保证赋值过了
  var _params$ccKey = params.ccKey,
      ccKey = _params$ccKey === void 0 ? '' : _params$ccKey,
      state = params.state,
      id = params.id,
      _params$ccOption = params.ccOption,
      ccOption = _params$ccOption === void 0 ? {} : _params$ccOption,
      module = params.module,
      ccClassKey = params.ccClassKey,
      type = params.type,
      insType = params.insType,
      _params$tag = params.tag,
      tag = _params$tag === void 0 ? '' : _params$tag,
      _params$storedKeys = params.storedKeys,
      storedKeys = _params$storedKeys === void 0 ? [] : _params$storedKeys,
      _params$persistStored = params.persistStoredKeys,
      persistStoredKeys = _params$persistStored === void 0 ? false : _params$persistStored,
      _params$watchedKeys = params.watchedKeys,
      watchedKeys = _params$watchedKeys === void 0 ? '-' : _params$watchedKeys,
      _params$connect = params.connect,
      connect = _params$connect === void 0 ? {} : _params$connect,
      _params$staticExtra = params.staticExtra,
      staticExtra = _params$staticExtra === void 0 ? {} : _params$staticExtra;
  var stateModule = module;
  var existedCtx = ref.ctx;
  var isCtxNull = isObjectNull(existedCtx); // 做个保护判断，防止 ctx = {}

  var modStateKeys = getModuleStateKeys(stateModule);
  var __boundSetState = ref.setState,
      __boundForceUpdate = ref.forceUpdate; // 如果已存在ctx，则直接指向原来的__bound，否则会造成无限递归调用栈溢出
  // 做个保护判断，防止 ctx = {}
  // const act = runtimeHandler.act;// for react-test-utils

  if (!isCtxNull && existedCtx.ccUniqueKey) {
    __boundSetState = existedCtx.__boundSetState;
    __boundForceUpdate = existedCtx.__boundForceUpdate;
  } else if (type !== _constant.CC_HOOK) {
    __boundSetState = ref.setState.bind(ref);
    __boundForceUpdate = ref.forceUpdate.bind(ref);
  }

  var refOption = {};
  refOption.persistStoredKeys = ccOption.persistStoredKeys === undefined ? persistStoredKeys : ccOption.persistStoredKeys;
  refOption.tag = ccOption.tag || tag; // pick ccOption tag first, register tag second

  var ccUniqueKey = (0, _computeCcUniqueKey["default"])(ccClassKey, ccKey, refOption.tag); // 没有设定renderKey的话读id，最后才默认renderKey为ccUniqueKey

  var tmpRenderKey = ccOption.renderKey || id;
  refOption.renderKey = tmpRenderKey !== undefined ? tmpRenderKey : ccUniqueKey;
  refOption.storedKeys = (0, _extractor.getStoredKeys)(stateModule, state, ccOption.storedKeys, storedKeys); // 用户使用ccKey属性的话，必需显示的指定ccClassKey

  if (ccKey && !ccClassKey) {
    throw new Error("missing ccClassKey while init a cc ins with ccKey[" + ccKey + "]");
  }

  if (refOption.storedKeys.length > 0) {
    if (!ccKey) throw me(_constant.ERR.CC_STORED_KEYS_NEED_CCKEY, vbi("ccClassKey[" + ccClassKey + "]"));
  }

  var mstate = getState(module); // recover ref state

  var refStoredState = refStore._state[ccUniqueKey] || {};
  var mergedState = Object.assign({}, state, refStoredState, mstate);
  ref.state = mergedState;
  var stateKeys = okeys(mergedState);
  var connectedModules = okeys(connect);
  var connectedComputed = {};
  connectedModules.forEach(function (m) {
    connectedComputed[m] = (0, _makeCuRefObContainer["default"])(ref, m, false);
  });
  var moduleComputed = (0, _makeCuRefObContainer["default"])(ref, module); // 所有实例都自动连接上了global模块，这里可直接取connectedComputed已做好的结果

  var globalComputed = connectedComputed[_constant.MODULE_GLOBAL];
  var globalState = (0, _makeObState["default"])(ref, getState(_constant.MODULE_GLOBAL), _constant.MODULE_GLOBAL, false); // extract privStateKeys

  var privStateKeys = util.removeArrElements(okeys(state), modStateKeys);
  var moduleState = module === _constant.MODULE_GLOBAL ? globalState : (0, _makeObState["default"])(ref, mstate, module, true); // declare cc state series api

  var changeState = function changeState(state, options) {
    (0, _changeRefState["default"])(state, options, ref);
  };

  var _setState = function _setState(module, state, calledBy, reactCallback, renderKey, delay) {
    var options = {
      calledBy: calledBy,
      module: module,
      reactCallback: reactCallback
    };
    if (util.isObject(renderKey)) Object.assign(options, renderKey); // 丢弃delay，renderKeyAsOpt里的delay
    else Object.assign(options, {
      renderKey: renderKey,
      delay: delay
    });
    changeState(state, options);
  };

  var setModuleState = function setModuleState(module, state, reactCallback, renderKey, delay) {
    _setState(module, state, _constant.SET_MODULE_STATE, reactCallback, renderKey, delay);
  };

  var setState = function setState(p1, p2, p3, p4, p5) {
    var p1Type = typeof p1;

    if (p1Type === 'string') {
      // p1: module, p2: state, p3: cb, p4: rkey, p5: delay
      setModuleState(p1, p2, p3, p4, p5);
    } else if (p1Type === 'function') {
      // p1: stateFn, p2: rkey, p3: delay
      var newState = p1(Object.assign({}, ctx.unProxyState), ctx.props);

      _setState(stateModule, newState, _constant.SET_STATE, p2, p3, p4);
    } else {
      // p1: state, p2: cb, p3: rkey, p4: delay
      _setState(stateModule, p1, _constant.SET_STATE, p2, p3, p4);
    }
  };

  var forceUpdate = function forceUpdate(reactCallback, renderKey, delay) {
    _setState(stateModule, ref.unProxyState, _constant.FORCE_UPDATE, reactCallback, renderKey, delay);
  };

  var refs = {};
  var allModules = connectedModules.slice(); // 已在change-ref-state里做优化，支持组件即属于又连接同一个模块，不会照成冗余渲染，
  // 所以此处allModules包含了module对渲染性能无影响，不过代码的语义上会照成重复的表达

  noDupPush(allModules, module);
  var props = (0, _getOutProps["default"])(ref.props);
  var now = Date.now();
  var ctx = {
    // static params
    type: type,
    insType: insType,
    module: module,
    ccClassKey: ccClassKey,
    ccKey: ccKey,
    ccUniqueKey: ccUniqueKey,
    renderCount: 0,
    initTime: now,
    watchedKeys: watchedKeys,
    privStateKeys: privStateKeys,
    connect: connect,
    connectedModules: connectedModules,
    allModules: allModules,
    // dynamic meta, I don't want user know these props, so let field name start with __$$
    __$$onEvents: [],
    // 当组件还未挂载时，将事件存到__$$onEvents里，当组件挂载时才开始真正监听事件
    __$$queuedUpdaters: [],
    __$$hasModuleState: modStateKeys.length > 0,
    __$$renderStatus: _privConstant.UNSTART,
    __$$curWaKeys: {},
    __$$compareWaKeys: {},
    __$$compareWaKeyCount: 0,
    // write before render
    __$$nextCompareWaKeys: {},
    __$$nextCompareWaKeyCount: 0,
    __$$curConnWaKeys: {},
    __$$compareConnWaKeys: {},
    __$$compareConnWaKeyCount: {},
    __$$nextCompareConnWaKeys: {},
    __$$nextCompareConnWaKeyCount: {},
    __$$staticWaKeys: {},
    // 用于快速的去重记录
    __$$staticWaKeyList: [],
    // 在实例didMount时由__$$staticWaKeys计算得出，用于辅助清理依赖映射
    persistStoredKeys: refOption.persistStoredKeys,
    storedKeys: refOption.storedKeys,
    renderKey: refOption.renderKey,
    tag: refOption.tag,
    prevProps: props,
    props: props,
    // collected mapProps result
    mapped: {},
    prevState: Object.assign({}, mergedState),
    // state
    state: (0, _makeObState["default"])(ref, mergedState, stateModule, true),
    unProxyState: mergedState,
    // 没有proxy化的state
    moduleState: moduleState,
    // 用于before-render里避免merge moduleState而导致的冗余触发get，此属性不暴露给用户使用，因其不具备依赖收集能力
    __$$mstate: mstate,
    globalState: globalState,
    connectedState: {},
    // for function: pass value to extra in every render period
    // for class: pass value to extra one time
    extra: isObject(params.extra) ? params.extra : {},
    // pass value to staticExtra only one time for both function and class
    staticExtra: staticExtra,
    settings: {},

    /** @type ICtx['refComputedValues'] */
    refComputedValues: {},

    /** @type ICtx['refComputedRawValues'] */
    refComputedRawValues: {},
    moduleComputed: moduleComputed,
    globalComputed: globalComputed,
    connectedComputed: connectedComputed,
    moduleReducer: null,
    mrc: null,
    // 仅生成描述体，moduleReducerCaller

    /** ghost reducer map */
    mrg: {},
    globalReducer: null,
    connectedReducer: {},
    reducer: {},
    // api meta data
    stateKeys: stateKeys,

    /** @type ICtx['computedDep'] */
    computedDep: {},
    computedRetKeyFns: {},

    /** @type ICtx['watchDep'] */
    watchDep: {},
    watchRetKeyFns: {},
    // 不按模块分类，映射的 watchRetKey2fns
    execute: null,
    retKey2fnUid: {},
    // api
    reactSetState: noop,
    // 等待重写
    __boundSetState: __boundSetState,
    reactForceUpdate: noop,
    // 等待重写
    __boundForceUpdate: __boundForceUpdate,
    setState: setState,
    setModuleState: setModuleState,
    forceUpdate: forceUpdate,
    changeState: changeState,
    // not expose in d.ts
    refs: refs,
    getRef: function getRef(refName) {
      return refs[refName] || null;
    },
    useRef: function useRef(refName) {
      return function (nodeRef) {
        // keep the same shape with hook useRef
        refs[refName] = {
          current: nodeRef
        };
      };
    },
    // below methods only can be called by cc or updated by cc in existed period, not expose in d.ts
    __$$ccSetState: hf.makeCcSetStateHandler(ref),
    __$$ccForceUpdate: hf.makeCcForceUpdateHandler(ref),
    __$$settedList: [],
    // [{module:string, keys:string[]}, ...]
    __$$prevMoStateVer: {},
    __$$prevModuleVer: getModuleVer(stateModule),
    __$$cuOrWaCalled: false
  };
  bindCtxToRef(isCtxNull, ref, ctx);
  ctx.refComputed = (0, _makeCuRefObContainer["default"])(ref, null, true, true);
  ref.setState = setState;
  ref.forceUpdate = forceUpdate;
  bindInitStateHandler(ref, ctx, state, refStoredState, mstate, modStateKeys);
  var dispatch = bindModApis(ref, ctx, stateModule, liteLevel, _setState);
  bindSyncApis(ref, ctx, liteLevel);
  bindEventApis(ctx, liteLevel, ccUniqueKey);
  bindEnhanceApis(ctx, liteLevel, stateModule);
  fillCtxOtherAttrs(ref, ctx, connect, watchedKeys, ccUniqueKey, stateModule, allModules, dispatch); // 始终优先取ref上指向的ctx，对于在热加载模式下的hook组件实例，那里面有的最近一次渲染收集的依赖信息才是正确的

  ctx.getWatchedKeys = function () {
    return getWatchedKeys(ref.ctx || ctx);
  };

  ctx.getConnectWatchedKeys = function (moduleName) {
    return getConnectWatchedKeys(ref.ctx || ctx, moduleName);
  };
}

var _default = buildRefCtx;
exports["default"] = _default;