"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = _default;

var util = _interopRequireWildcard(require("../../support/util"));

var _ccContext = _interopRequireDefault(require("../../cc-context"));

var cache = _interopRequireWildcard(require("./_cache"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var okeys = util.okeys,
    isEmptyVal = util.isEmptyVal;
var ccUKey2ref = _ccContext["default"].ccUKey2ref,
    waKey2uKeyMap = _ccContext["default"].waKey2uKeyMap,
    waKey2staticUKeyMap = _ccContext["default"].waKey2staticUKeyMap;

function _default(moduleName, partialSharedState, renderKeys, renderKeyClasses) {
  var sharedStateKeys = okeys(partialSharedState);
  var cacheKey = cache.getCacheKey(moduleName, sharedStateKeys, renderKeys, renderKeyClasses);
  var cachedResult = cache.getCache(moduleName, cacheKey);

  if (cachedResult) {
    return {
      sharedStateKeys: sharedStateKeys,
      result: cachedResult
    };
  }

  var targetUKeyMap = {};
  var belongRefKeys = [];
  var connectRefKeys = [];
  sharedStateKeys.forEach(function (stateKey) {
    var waKey = moduleName + "/" + stateKey; // 利用assign不停的去重

    Object.assign(targetUKeyMap, waKey2uKeyMap[waKey], waKey2staticUKeyMap[waKey]);
  });
  var uKeys = okeys(targetUKeyMap);

  var putRef = function putRef(isBelong, ccUniqueKey) {
    isBelong ? belongRefKeys.push(ccUniqueKey) : connectRefKeys.push(ccUniqueKey);
  };

  var tryMatch = function tryMatch(ref, toBelong) {
    var _ref$ctx = ref.ctx,
        refRenderKey = _ref$ctx.renderKey,
        refCcClassKey = _ref$ctx.ccClassKey,
        ccUniqueKey = _ref$ctx.ccUniqueKey,
        props = _ref$ctx.props; // 如果调用方携带renderKey发起修改状态动作，则需要匹配renderKey做更新

    if (renderKeys.length) {
      var isRenderKeyMatched = renderKeys.includes(refRenderKey); // 所有的类实例都受renderKey匹配机制影响
      // or 携带id生成了renderKey

      if (renderKeyClasses === '*' || !isEmptyVal(props.id)) {
        if (isRenderKeyMatched) {
          putRef(toBelong, ccUniqueKey);
        }

        return;
      } // 这些指定类实例受renderKey机制影响


      if (renderKeyClasses.includes(refCcClassKey)) {
        if (isRenderKeyMatched) {
          putRef(toBelong, ccUniqueKey);
        }
      } else {
        // 这些实例则不受renderKey机制影响
        putRef(toBelong, ccUniqueKey);
      }
    } else {
      putRef(toBelong, ccUniqueKey);
    }
  };

  var missRef = false;
  uKeys.forEach(function (key) {
    var ref = ccUKey2ref[key];

    if (!ref) {
      missRef = true;
      return;
    }

    var refCtx = ref.ctx;
    var refModule = refCtx.module,
        refConnect = refCtx.connect;
    var isBelong = refModule === moduleName;
    var isConnect = refConnect[moduleName] ? true : false;

    if (isBelong) {
      tryMatch(ref, true);
    } // 一个实例如果既属于模块x同时也连接了模块x，这是不推荐的，在buildCtx里面已给出警告
    // 会造成冗余的渲染


    if (isConnect) {
      tryMatch(ref, false);
    }
  });
  var result = {
    belong: belongRefKeys,
    connect: connectRefKeys
  }; // 没有miss的ref才存缓存，防止直接标记了watchedKeys的实例此时还没有记录ref，
  // 但是此时刚好有变更状态的命令的话，如果这里缓存了查询结果，这这个实例挂上后，没有机会响应状态变更了

  if (!missRef) {
    cache.setCache(moduleName, cacheKey, result);
  }

  return {
    sharedStateKeys: sharedStateKeys,
    result: result
  };
}