"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = _default;

var _ccContext = _interopRequireDefault(require("../../cc-context"));

var _util = require("../../support/util");

var _constant = require("../../support/constant");

/* eslint-disable camelcase */

/** @typedef {import('../../types-inner').IRef} Ref */
function _default(filters) {
  var ccUKey2ref = _ccContext["default"].ccUKey2ref;
  var _filters = {};
  if (typeof filters === 'string') _filters = {
    ccClassKey: filters
  };else if ((0, _util.isObject)(filters)) _filters = filters;
  var _filters2 = _filters,
      ccClassKey = _filters2.ccClassKey,
      tag = _filters2.tag,
      moduleName = _filters2.moduleName,
      _filters2$includeNotM = _filters2.includeNotMount,
      includeNotMount = _filters2$includeNotM === void 0 ? false : _filters2$includeNotM;
  var refs = [];
  var ukeys = (0, _util.okeys)(ccUKey2ref);
  var len = ukeys.length;

  var isEqual = function isEqual(passedVal, ctxVal) {
    if (!passedVal) return true;
    return passedVal === ctxVal;
  };

  for (var i = 0; i < len; i++) {
    /** @type Ref */
    var ref = ccUKey2ref[ukeys[i]];
    var mountStatus = ref.__$$ms;

    if (includeNotMount) {
      // allow NOT_MOUNT, MOUNTED
      if (mountStatus === _constant.UNMOUNTED) continue;
    } else {
      // only allow MOUNTED
      if (mountStatus !== _constant.MOUNTED) continue;
    }

    var ctx = ref.ctx;

    if (isEqual(ccClassKey, ctx.ccClassKey) && isEqual(tag, ctx.tag) && isEqual(moduleName, ctx.module)) {
      refs.push(ref);
    }
  }

  return refs;
}