"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var util = _interopRequireWildcard(require("../../support/util"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function setValue(obj, keys, lastKeyIndex, keyIndex, value, isToggleBool) {
  if (isToggleBool === void 0) {
    isToggleBool = false;
  }

  var key = keys[keyIndex];
  var oriVal = obj[key];

  if (lastKeyIndex === keyIndex) {
    if (isToggleBool === true) {
      if (typeof oriVal !== 'boolean') {
        util.justWarning("key[" + key + "]'s value type is not boolean");
      } else {
        obj[key] = !oriVal;
      }
    } else {
      obj[key] = value;
    }
  } else {
    var newVal = util.shallowCopy(oriVal);
    obj[key] = newVal;
    setValue(newVal, keys, lastKeyIndex, ++keyIndex, value, isToggleBool);
  }
}

var _default = function _default(ccsync, value, ccint, oriState, isToggleBool, refModule) {
  var _value = value;

  if (ccint === true) {
    _value = parseInt(value); // strict?

    if (Number.isNaN(_value)) {
      util.justWarning(value + " can not convert to int but you set ccint as true!");
      _value = value;
    }
  }

  var module = refModule,
      keys = [];

  if (ccsync.includes('/')) {
    var _ccsync$split = ccsync.split('/'),
        _module = _ccsync$split[0],
        keyOrKeyPath = _ccsync$split[1];

    module = _module;

    if (keyOrKeyPath.includes('.')) {
      keys = keyOrKeyPath.split('.');
    } else {
      keys = [keyOrKeyPath];
    }
  } else if (ccsync.includes('.')) {
    keys = ccsync.split('.');
  } else {
    keys = [ccsync];
  }

  var keyPath = keys.join('.');

  if (keys.length === 1) {
    var targetStateKey = keys[0];

    if (isToggleBool === true) {
      var _state;

      return {
        module: module,
        keys: keys,
        keyPath: keyPath,
        state: (_state = {}, _state[targetStateKey] = !oriState[targetStateKey], _state)
      };
    } else {
      var _state2;

      return {
        module: module,
        keys: keys,
        keyPath: keyPath,
        state: (_state2 = {}, _state2[targetStateKey] = _value, _state2)
      };
    }
  } else {
    var _state3;

    var _keys = keys,
        key = _keys[0],
        restKeys = _keys.slice(1);

    var subState = util.shallowCopy(oriState[key]);
    setValue(subState, restKeys, restKeys.length - 1, 0, _value, isToggleBool);
    return {
      module: module,
      keys: keys,
      keyPath: keyPath,
      state: (_state3 = {}, _state3[key] = subState, _state3)
    };
  }
};

exports["default"] = _default;