"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.dispatch = dispatch;
exports.invokeWith = invokeWith;
exports.makeCcForceUpdateHandler = makeCcForceUpdateHandler;
exports.makeCcSetStateHandler = makeCcSetStateHandler;
exports.makeDispatchHandler = makeDispatchHandler;
exports.makeInvokeHandler = makeInvokeHandler;
exports.makeModuleDispatcher = makeModuleDispatcher;
exports.makeRefSetState = exports.makeRefForceUpdate = void 0;
exports.makeSetStateHandler = makeSetStateHandler;

var _constant = require("../../support/constant");

var _ccContext = _interopRequireDefault(require("../../cc-context"));

var util = _interopRequireWildcard(require("../../support/util"));

var _dispatch2 = _interopRequireDefault(require("../base/dispatch"));

var _chain = require("../chain");

var _plugin = require("../plugin");

var checker = _interopRequireWildcard(require("../param/checker"));

var _changeRefState = _interopRequireDefault(require("../state/change-ref-state"));

var _setState = require("./set-state");

var _extractStateByKeys2 = _interopRequireDefault(require("./extract-state-by-keys"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

// import hoistNonReactStatic from 'hoist-non-react-statics';
var verboseInfo = util.verboseInfo,
    makeError = util.makeError,
    justWarning = util.justWarning,
    isPJO = util.isPJO,
    okeys = util.okeys,
    isValueNotNull = util.isValueNotNull;
var _ccContext$store = _ccContext["default"].store,
    getState = _ccContext$store.getState,
    storeSetState = _ccContext$store.setState,
    _reducer = _ccContext["default"].reducer._reducer,
    _computedValues = _ccContext["default"].computed._computedValues,
    runtimeHandler = _ccContext["default"].runtimeHandler,
    runtimeVar = _ccContext["default"].runtimeVar;
var me = makeError;
var vbi = verboseInfo;

function handleError(err, throwError) {
  if (throwError === void 0) {
    throwError = true;
  }

  if (throwError) throw err;else {
    handleCcFnError(err);
  }
}

function checkStoreModule(module, throwError) {
  if (throwError === void 0) {
    throwError = true;
  }

  try {
    checker.checkModuleName(module, false, "module[" + module + "] is not configured in store");
    return true;
  } catch (err) {
    handleError(err, throwError);
    return false;
  }
}

function paramCallBackShouldNotSupply(module, currentModule) {
  return "param module[" + module + "] must equal current ref's module[" + currentModule + "] when pass param reactCallback, or it will never been triggered! ";
}

function _promiseErrorHandler(resolve, reject) {
  return function (err) {
    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    return err ? reject(err) : resolve.apply(void 0, args);
  };
} //忽略掉传递进来的chainId，chainDepth，重新生成它们，源头调用了lazyDispatch或者ctx里调用了lazyDispatch，就会触发此逻辑


function getNewChainData(isLazy, chainId, oriChainId, chainId2depth) {
  var _chainId;

  if (isLazy === true) {
    _chainId = (0, _chain.getChainId)();
    (0, _chain.setChainIdLazy)(_chainId);
    chainId2depth[_chainId] = 1; //置为1
  } else {
    _chainId = chainId || (0, _chain.getChainId)();
    if (!chainId2depth[_chainId]) chainId2depth[_chainId] = 1;
  } //源头函数会触发创建oriChainId， 之后就一直传递下去了


  var _oriChainId = oriChainId || _chainId;

  return {
    _chainId: _chainId,
    _oriChainId: _oriChainId
  };
} // any error in this function will not been throw, cc just warning, 


function isStateModuleValid(inputModule, currentModule, reactCallback, cb) {
  var targetCb = reactCallback;

  if (checkStoreModule(inputModule, false)) {
    if (inputModule !== currentModule && reactCallback) {
      // ???strict
      justWarning(paramCallBackShouldNotSupply(inputModule, currentModule));
      targetCb = null; // let user's reactCallback has no chance to be triggered
    }

    cb(null, targetCb);
  } else {
    cb(new Error("inputModule:" + inputModule + " invalid"), null);
  }
}

function handleCcFnError(err, __innerCb) {
  if (err) {
    if (__innerCb) __innerCb(err);else {
      _ccContext["default"].runtimeHandler.tryHandleError(err);
    }
  }
}

function _promisifyCcFn(ccFn, userLogicFn, executionContext, payload) {
  return new Promise(function (resolve, reject) {
    var _executionContext = Object.assign(executionContext, {
      __innerCb: _promiseErrorHandler(resolve, reject)
    });

    ccFn(userLogicFn, _executionContext, payload);
  })["catch"](runtimeHandler.tryHandleError);
}

function __promisifiedInvokeWith(userLogicFn, executionContext, payload) {
  return _promisifyCcFn(invokeWith, userLogicFn, executionContext, payload);
}

function __invoke(userLogicFn, option, payload) {
  var callerRef = option.callerRef,
      delay = option.delay,
      renderKey = option.renderKey,
      force = option.force,
      calledBy = option.calledBy,
      module = option.module,
      chainId = option.chainId,
      oriChainId = option.oriChainId,
      chainId2depth = option.chainId2depth,
      isSilent = option.isSilent; // 有可能直接 invoke 模块 reducer 里的方法

  var fnName = userLogicFn.__fnName || userLogicFn.name;
  return __promisifiedInvokeWith(userLogicFn, {
    callerRef: callerRef,
    context: true,
    module: module,
    calledBy: calledBy,
    fnName: fnName,
    delay: delay,
    renderKey: renderKey,
    force: force,
    chainId: chainId,
    oriChainId: oriChainId,
    chainId2depth: chainId2depth,
    isSilent: isSilent
  }, payload);
} // 后面会根据具体组件形态给reactSetState赋值
// 直接写为 makeCcSetStateHandler = (ref)=> ref.ctx.reactSetState, 是错误的
// ref.ctx.reactSetState是在后面的流程里被赋值的，所以此处多用一层函数包裹再调用


function makeCcSetStateHandler(ref) {
  return function (state, cb) {
    ref.ctx.reactSetState(state, cb);
  };
}

function makeCcForceUpdateHandler(ref) {
  return function (cb) {
    ref.ctx.reactForceUpdate(cb);
  };
} // last param: chainData


function makeInvokeHandler(callerRef, _temp) {
  var _ref = _temp === void 0 ? {} : _temp,
      chainId = _ref.chainId,
      oriChainId = _ref.oriChainId,
      isLazy = _ref.isLazy,
      _ref$delay = _ref.delay,
      delay = _ref$delay === void 0 ? -1 : _ref$delay,
      _ref$isSilent = _ref.isSilent,
      isSilent = _ref$isSilent === void 0 ? false : _ref$isSilent,
      _ref$chainId2depth = _ref.chainId2depth,
      chainId2depth = _ref$chainId2depth === void 0 ? {} : _ref$chainId2depth;

  return function (firstParam, payload, inputRKey, inputDelay) {
    var _isLazy = isLazy,
        _isSilent = isSilent;

    var _renderKey = '',
        _delay = inputDelay != undefined ? inputDelay : delay;

    var _force = false;

    if (isPJO(inputRKey)) {
      var lazy = inputRKey.lazy,
          silent = inputRKey.silent,
          renderKey = inputRKey.renderKey,
          _delay2 = inputRKey.delay,
          force = inputRKey.force;
      lazy !== undefined && (_isLazy = lazy);
      silent !== undefined && (_isSilent = silent);
      renderKey !== undefined && (_renderKey = renderKey);
      _delay2 !== undefined && (_delay = _delay2);
      _force = force;
    } else {
      _renderKey = inputRKey;
    }

    var _getNewChainData = getNewChainData(_isLazy, chainId, oriChainId, chainId2depth),
        _chainId = _getNewChainData._chainId,
        _oriChainId = _getNewChainData._oriChainId;

    var firstParamType = typeof firstParam;
    var option = {
      callerRef: callerRef,
      calledBy: _constant.INVOKE,
      module: callerRef.ctx.module,
      isSilent: _isSilent,
      chainId: _chainId,
      oriChainId: _oriChainId,
      chainId2depth: chainId2depth,
      delay: _delay,
      renderKey: _renderKey,
      force: _force
    }; // eslint-disable-next-line

    var err = new Error("param type error, correct usage: invoke(userFn:function, ...args:any[]) or invoke(option:[module:string, fn:function], ...args:any[])");

    if (firstParamType === 'function') {
      // 可能用户直接使用invoke调用了reducer函数
      if (firstParam.__fnName) firstParam.name = firstParam.__fnName; // 这里不修改option.module，concent明确定义了dispatch和invoke规则

      /**
        invoke调用函数引用时
        无论组件有无注册模块，一定走调用方模块
         dispatch调用函数引用时
        优先走函数引用的模块（此时函数是一个reducer函数），没有(此函数不是reducer函数)则走调用方的模块并降级为invoke调用
       */
      // if (firstParam.__stateModule) option.module = firstParam.__stateModule;

      return __invoke(firstParam, option, payload);
    } else if (firstParamType === 'object') {
      var _fn, _module;

      if (Array.isArray(firstParam)) {
        var module = firstParam[0],
            fn = firstParam[1];
        _fn = fn;
        _module = module;
      } else {
        var _module2 = firstParam.module,
            _fn2 = firstParam.fn;
        _fn = _fn2;
        _module = _module2;
      }

      if (!util.isFn(_fn)) throw err;
      if (_module) option.module = _module; //某个模块的实例修改了另外模块的数据

      return __invoke(_fn, option, payload);
    } else {
      throw err;
    }
  };
}

function invokeWith(userLogicFn, executionContext, payload) {
  var callerRef = executionContext.callerRef;
  var callerModule = callerRef.ctx.module;
  var _executionContext$mod = executionContext.module,
      targetModule = _executionContext$mod === void 0 ? callerModule : _executionContext$mod,
      _executionContext$con = executionContext.context,
      context = _executionContext$con === void 0 ? false : _executionContext$con,
      cb = executionContext.cb,
      __innerCb = executionContext.__innerCb,
      type = executionContext.type,
      calledBy = executionContext.calledBy,
      _executionContext$fnN = executionContext.fnName,
      fnName = _executionContext$fnN === void 0 ? '' : _executionContext$fnN,
      _executionContext$del = executionContext.delay,
      delay = _executionContext$del === void 0 ? -1 : _executionContext$del,
      renderKey = executionContext.renderKey,
      _executionContext$for = executionContext.force,
      force = _executionContext$for === void 0 ? false : _executionContext$for,
      chainId = executionContext.chainId,
      oriChainId = executionContext.oriChainId,
      chainId2depth = executionContext.chainId2depth,
      isSilent = executionContext.isSilent;
  isStateModuleValid(targetModule, callerModule, cb, function (err, newCb) {
    if (err) return handleCcFnError(err, __innerCb);
    var moduleStateBase = getState(targetModule);
    var moduleState = moduleStateBase;
    var actionContext = {};
    var isSourceCall = false;
    var immutLib = runtimeHandler.immutLib;

    if (immutLib) {
      moduleState = immutLib.createDraft(moduleStateBase);
    }

    isSourceCall = chainId === oriChainId && chainId2depth[chainId] === 1;

    if (context) {
      // 调用前先加1
      chainId2depth[chainId] = chainId2depth[chainId] + 1; // !!!makeDispatchHandler的dispatch lazyDispatch将源头的isSilent 一致透传下去

      var _dispatch = makeDispatchHandler(callerRef, false, isSilent, targetModule, renderKey, delay, chainId, oriChainId, chainId2depth);

      var silentDispatch = makeDispatchHandler(callerRef, false, true, targetModule, renderKey, delay, chainId, oriChainId, chainId2depth);
      var lazyDispatch = makeDispatchHandler(callerRef, true, isSilent, targetModule, renderKey, delay, chainId, oriChainId, chainId2depth); // oriChainId, chainId2depth 一直携带下去，设置isLazy，会重新生成chainId

      var invoke = makeInvokeHandler(callerRef, {
        delay: delay,
        chainId: chainId,
        oriChainId: oriChainId,
        chainId2depth: chainId2depth
      });
      var lazyInvoke = makeInvokeHandler(callerRef, {
        isLazy: true,
        delay: delay,
        oriChainId: oriChainId,
        chainId2depth: chainId2depth
      });
      var silentInvoke = makeInvokeHandler(callerRef, {
        isLazy: false,
        delay: delay,
        isSilent: true,
        oriChainId: oriChainId,
        chainId2depth: chainId2depth
      }); // 首次调用时是undefined，这里做个保护

      var committedStateMap = (0, _chain.getAllChainStateMap)(chainId) || {};
      var committedState = committedStateMap[targetModule] || {};
      actionContext = {
        callInfo: {
          renderKey: renderKey,
          delay: delay,
          fnName: fnName,
          type: type,
          calledBy: calledBy,
          force: force
        },
        module: targetModule,
        callerModule: callerModule,
        committedStateMap: committedStateMap,
        // 一次ref dispatch调用，所经过的所有reducer的返回结果收集
        committedState: committedState,
        invoke: invoke,
        lazyInvoke: lazyInvoke,
        silentInvoke: silentInvoke,
        invokeLazy: lazyInvoke,
        invokeSilent: silentInvoke,
        dispatch: _dispatch,
        lazyDispatch: lazyDispatch,
        silentDispatch: silentDispatch,
        dispatchLazy: lazyDispatch,
        dispatchSilent: silentDispatch,
        rootState: getState(),
        globalState: getState(_constant.MODULE_GLOBAL),
        // 指的是目标模块的state
        moduleState: moduleState,
        // 指的是目标模块的的moduleComputed
        moduleComputed: _computedValues[targetModule] || {},
        // 利用dispatch调用自动生成的setState
        setState: function setState(state, r, d) {
          var targetR = r !== 0 ? r || renderKey : r;
          var targetD = d !== 0 ? d || delay : d;
          return _dispatch('setState', state, {
            silent: isSilent,
            renderKey: targetR,
            delay: targetD
          });
        },
        // !!!指的是调用源cc实例的ctx
        refCtx: callerRef.ctx,
        // 方便直接获取并标记 refState 类型
        refState: callerRef.ctx.state // concent不鼓励用户在reducer使用ref相关数据书写业务逻辑，除非用户确保是同一个模块的实例触发调用该函数，
        // 因为不同调用方传递不同的refCtx值，会引起用户不注意的bug

      };
    }

    if (isSilent === false) {
      (0, _plugin.send)(_constant.SIG_FN_START, {
        isSourceCall: isSourceCall,
        calledBy: calledBy,
        module: targetModule,
        chainId: chainId,
        fn: userLogicFn,
        type: type
      });
    }

    var handleReturnState = function handleReturnState(partialState) {
      chainId2depth[chainId] = chainId2depth[chainId] - 1; // 调用结束减1

      var curDepth = chainId2depth[chainId];
      var isFirstDepth = curDepth === 1;
      var isC2Result = stOrPromisedSt && stOrPromisedSt.__c2Result; // 调用结束就记录

      (0, _chain.setAllChainState)(chainId, targetModule, partialState);
      var commitStateList = [];

      if (isSilent === false) {
        (0, _plugin.send)(_constant.SIG_FN_END, {
          isSourceCall: isSourceCall,
          calledBy: calledBy,
          module: targetModule,
          chainId: chainId,
          fn: userLogicFn
        }); // targetModule, sourceModule相等与否不用判断了，chainState里按模块为key去记录提交到不同模块的state

        if ((0, _chain.isChainIdLazy)(chainId)) {
          // 来自于惰性派发的调用
          if (!isFirstDepth) {
            // 某条链还在往下调用中，没有回到第一层，暂存状态，直到回到第一层才提交
            (0, _chain.setChainState)(chainId, targetModule, partialState);
          } else {
            // 合并状态一次性提交到store并派发到组件实例
            if ((0, _chain.isChainExited)(chainId)) {// 丢弃本次状态，不做任何处理
            } else {
              commitStateList = (0, _chain.setAndGetChainStateList)(isC2Result, chainId, targetModule, partialState);
              (0, _chain.removeChainState)(chainId);
            }
          }
        } else {
          if (!isC2Result) commitStateList = [{
            module: targetModule,
            state: partialState
          }];
        }
      } else {
        if (immutLib) {
          immutLib.finishDraft();
        }
      }

      commitStateList.forEach(function (v) {
        var changedPartialState = v.state;
        var stateSnapshot = moduleState;

        if (immutLib) {
          stateSnapshot = immutLib.finishDraft(moduleState); // 可能未对 moduleState 做任何修改，做了修改才重置 changedPartialState

          if (moduleStateBase !== stateSnapshot) {
            changedPartialState = okeys(changedPartialState).reduce(function (tmpMap, stateKey) {
              var finalVal = stateSnapshot[stateKey];

              if (util.isPJO(finalVal, true)) {
                tmpMap[stateKey] = finalVal;
              } else {
                tmpMap[stateKey] = changedPartialState[stateKey];
              }

              return tmpMap;
            }, {});
          }
        }

        (0, _changeRefState["default"])(changedPartialState, {
          renderKey: renderKey,
          module: v.module,
          reactCallback: newCb,
          type: type,
          calledBy: calledBy,
          fnName: fnName,
          delay: delay,
          payload: payload,
          force: force,
          stateSnapshot: stateSnapshot
        }, callerRef);
      });

      if (isSourceCall) {
        // 源头 dispatch 或 invoke 结束调用
        (0, _chain.removeChainState)(chainId);
        (0, _chain.removeAllChainState)(chainId);
      }

      if (__innerCb) __innerCb(null, partialState);
    };

    var handleFnError = function handleFnError(err) {
      (0, _plugin.send)(_constant.SIG_FN_ERR, {
        isSourceCall: isSourceCall,
        calledBy: calledBy,
        module: targetModule,
        chainId: chainId,
        fn: userLogicFn
      });
      handleCcFnError(err, __innerCb);
    };

    var stOrPromisedSt = userLogicFn(payload, moduleState, actionContext);

    if (userLogicFn.__isAsync) {
      Promise.resolve(stOrPromisedSt).then(handleReturnState)["catch"](handleFnError);
    } else {
      // 防止输入中文时，因为隔了一个Promise而出现抖动
      try {
        if (userLogicFn.__isReturnJudged) {
          handleReturnState(stOrPromisedSt);
          return;
        } // 再判断一次，有可能会被编译器再包一层，形如：
        //  function getServerStore(_x2) {
        //    return _getServerStore.apply(this, arguments);
        //  }


        if (util.isAsyncFn(stOrPromisedSt)) {
          userLogicFn.__isAsync = true;
          Promise.resolve(stOrPromisedSt).then(handleReturnState)["catch"](handleFnError);
          return;
        } else {
          userLogicFn.__isReturnJudged = true;
        }

        handleReturnState(stOrPromisedSt);
      } catch (err) {
        handleFnError(err);
      }
    }
  });
}

function dispatch(_temp2) {
  var _ref2 = _temp2 === void 0 ? {} : _temp2,
      callerRef = _ref2.callerRef,
      inputModule = _ref2.module,
      renderKey = _ref2.renderKey,
      isSilent = _ref2.isSilent,
      force = _ref2.force,
      type = _ref2.type,
      payload = _ref2.payload,
      reactCallback = _ref2.cb,
      __innerCb = _ref2.__innerCb,
      _ref2$delay = _ref2.delay,
      delay = _ref2$delay === void 0 ? -1 : _ref2$delay,
      chainId = _ref2.chainId,
      oriChainId = _ref2.oriChainId,
      chainId2depth = _ref2.chainId2depth;

  var targetReducerFns = _reducer[inputModule] || {};
  var reducerFn = targetReducerFns[type];

  if (!reducerFn) {
    var fns = okeys(targetReducerFns);
    var err = new Error("reducer fn [" + inputModule + "/" + type + "] not found, you may call:" + fns);
    return __innerCb(err);
  }

  var executionContext = {
    callerRef: callerRef,
    module: inputModule,
    type: type,
    force: force,
    fnName: type,
    cb: reactCallback,
    context: true,
    __innerCb: __innerCb,
    calledBy: _constant.DISPATCH,
    delay: delay,
    renderKey: renderKey,
    isSilent: isSilent,
    chainId: chainId,
    oriChainId: oriChainId,
    chainId2depth: chainId2depth
  };
  invokeWith(reducerFn, executionContext, payload);
}

function makeDispatchHandler(callerRef, inputIsLazy, inputIsSilent, defaultModule, defaultRenderKey, delay, chainId, oriChainId, chainId2depth // sourceModule, oriChainId, oriChainDepth
) {
  if (defaultRenderKey === void 0) {
    defaultRenderKey = '';
  }

  if (delay === void 0) {
    delay = -1;
  }

  if (chainId2depth === void 0) {
    chainId2depth = {};
  }

  // return Promise<any>
  return function (paramObj, payload, userInputRKey, userInputDelay) {
    if (!isValueNotNull(paramObj)) {
      return Promise.reject(new Error('dispatch param is null/undefined'));
    }

    var isLazy = inputIsLazy,
        isSilent = inputIsSilent;
    var _renderKey = '';

    var _delay = userInputDelay || delay;

    var _force = false;

    if (isPJO(userInputRKey)) {
      _renderKey = defaultRenderKey;
      var lazy = userInputRKey.lazy,
          silent = userInputRKey.silent,
          renderKey = userInputRKey.renderKey,
          _delay3 = userInputRKey.delay,
          force = userInputRKey.force;
      lazy !== undefined && (isLazy = lazy);
      silent !== undefined && (isSilent = silent);
      renderKey !== undefined && (_renderKey = renderKey);
      _delay3 !== undefined && (_delay = _delay3);
      _force = force;
    } else {
      _renderKey = userInputRKey || defaultRenderKey;
    }

    var _getNewChainData2 = getNewChainData(isLazy, chainId, oriChainId, chainId2depth),
        _chainId = _getNewChainData2._chainId,
        _oriChainId = _getNewChainData2._oriChainId;

    var paramObjType = typeof paramObj;

    var _type, _cb;

    var _module = defaultModule;

    var callInvoke = function callInvoke() {
      var iHandler = makeInvokeHandler(callerRef, {
        chainId: _chainId,
        oriChainId: _oriChainId,
        isLazy: isLazy,
        isSilent: isSilent,
        chainId2depth: chainId2depth
      });
      return iHandler(paramObj, payload, {
        renderKey: _renderKey,
        delay: _delay,
        force: _force
      });
    };

    if (paramObjType === 'object') {
      // [ moduleName: string, reducerFn: Function ]
      if (Array.isArray(paramObj)) {
        var mInArr = paramObj[0],
            rInArr = paramObj[1];

        if (rInArr && rInArr.__fnName) {
          _module = mInArr;
          _type = rInArr.__fnName;
        } else {
          return callInvoke();
        }
      } else {
        var module = paramObj.module,
            fn = paramObj.fn,
            type = paramObj.type,
            cb = paramObj.cb;
        if (module) _module = module;

        if (fn && fn.__fnName) {
          _type = fn.__fnName; // 未指定module，才默认走 reducer函数的所属模块

          if (!module) _module = fn.__stateModule;
        } else {
          if (typeof type !== 'string') {
            return Promise.reject(new Error('dispatchDesc.type must be string'));
          }

          _type = type;
        }

        _cb = cb;
      }
    } else if (paramObjType === 'string' || paramObjType === 'function') {
      var targetFirstParam = paramObj;

      if (paramObjType === 'function') {
        var fnName = paramObj.__fnName;

        if (!fnName) {
          // 此函数是一个普通函数，没有配置到某个模块的reducer里，降级为invoke调用
          return callInvoke();
        }

        targetFirstParam = fnName; // 这里非常重要，只有处于第一层的调用时，才获取函数对象上的__stateModule参数
        // 防止克隆自模块a的模块b在reducer文件里基于函数引用直接调用时，取的是a的模块相关参数了，但是源头由b发起，应该是b才对

        if (chainId2depth[_oriChainId] == 1) {
          // let dispatch can apply reducer function directly!!!
          // !!! 如果用户在b模块的组件里dispatch直接调用a模块的函数，但是确实想修改的是b模块的数据，只是想复用a模块的那个函数的逻辑
          // 那么千万要注意，写为{module:'b', fn:xxxFoo}的模式
          _module = paramObj.__stateModule;
        }
      }

      var slashCount = targetFirstParam.split('').filter(function (v) {
        return v === '/';
      }).length;

      if (slashCount === 0) {
        _type = targetFirstParam;
      } else if (slashCount === 1) {
        var _targetFirstParam$spl = targetFirstParam.split('/'),
            _module3 = _targetFirstParam$spl[0],
            _type2 = _targetFirstParam$spl[1];

        if (_module3) _module = _module3; //targetFirstParam may like: /foo/changeName

        _type = _type2;
      } else {
        return Promise.reject(me(_constant.ERR.CC_DISPATCH_STRING_INVALID, vbi(targetFirstParam)));
      }
    } else {
      return Promise.reject(me(_constant.ERR.CC_DISPATCH_PARAM_INVALID));
    }

    if (_module === '*') {
      return (0, _dispatch2["default"])("*/" + _type, payload, {
        silent: isSilent,
        lazy: isLazy,
        renderKey: _renderKey,
        force: _force
      }, _delay, {
        refModule: callerRef.ctx.module
      } // in name of refModule to call dispatch handler
      );
    }

    var p = new Promise(function (resolve, reject) {
      dispatch({
        callerRef: callerRef,
        module: _module,
        type: _type,
        payload: payload,
        cb: _cb,
        __innerCb: _promiseErrorHandler(resolve, reject),
        delay: _delay,
        renderKey: _renderKey,
        isSilent: isSilent,
        force: _force,
        chainId: _chainId,
        oriChainId: _oriChainId,
        chainId2depth: chainId2depth // oriChainId: _oriChainId, oriChainDepth: _oriChainDepth, sourceModule: _sourceModule,

      });
    })["catch"](function (err) {
      // 强烈不建议用户配置 unsafe_moveReducerErrToErrorHandler 为 true，转发 reducer 错误到 errorHandler 里
      // 保留这个参数是为了让老版本的concent工程能够正常工作
      if (runtimeVar.unsafe_moveReducerErrToErrorHandler) {
        // 非严格模式，如果未配置 errorHandler，错误会被静默掉
        runtimeHandler.tryHandleError(err, !runtimeVar.isStrict);
      } else {
        throw err;
      }
    });
    /**
     * 用于帮助concent识别出这是用户直接返回的Promise对象，减少一次冗余的渲染
     *   function demoMethod(p,m,ac){
     *     // ac.setState已经触发了一次渲染
     *     // demoMethod可以不用再触发渲染了
     *     return ac.setState({num1:1}); 
     *   }
     */

    p.__c2Result = true;
    return p;
  };
}

function makeModuleDispatcher(module) {
  return function (action) {
    var _action = typeof action === 'string' && !action.includes('/') ? module + "/" + action : action;

    for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
      args[_key2 - 1] = arguments[_key2];
    }

    return _dispatch2["default"].apply(void 0, [_action].concat(args));
  };
} // for moduleConf.init(legency) moduleConf.lifecycle.initState(v2.9+)


function makeSetStateHandler(module, initStateDone) {
  return function (state) {
    var execInitDoneWrap = function execInitDoneWrap() {
      return initStateDone && initStateDone(makeModuleDispatcher(module), getState(module));
    };

    try {
      if (!state) return void execInitDoneWrap();
      (0, _setState.innerSetState)(module, state, execInitDoneWrap);
    } catch (err) {
      var moduleState = getState(module);

      if (!moduleState) {
        return justWarning("invalid module " + module);
      }

      var keys = okeys(moduleState);

      var _extractStateByKeys = (0, _extractStateByKeys2["default"])(state, keys, false, true),
          partialState = _extractStateByKeys.partialState,
          isStateEmpty = _extractStateByKeys.isStateEmpty,
          ignoredStateKeys = _extractStateByKeys.ignoredStateKeys;

      if (!isStateEmpty) storeSetState(module, partialState); //store this valid state;

      if (ignoredStateKeys.length > 0) {
        justWarning("invalid keys:" + ignoredStateKeys.join(',') + ", their value is undefined or they are not declared in module" + module);
      }

      util.justTip("no ccInstance found for module[" + module + "] currently, cc will just store it, lately ccInstance will pick this state to render");
      execInitDoneWrap();
    }
  };
}

var makeRefSetState = function makeRefSetState(ref) {
  return function (partialState, cb) {
    var ctx = ref.ctx;
    var newState = Object.assign({}, ctx.unProxyState, partialState);
    ctx.unProxyState = newState; // 和class setState(partialState, cb); 保持一致

    var cbNewState = function cbNewState() {
      return cb && cb(newState);
    }; // 让ctx.state始终保持同一个引用，使setup里可以安全的解构state反复使用


    ctx.state = Object.assign(ctx.state, partialState);
    var act = runtimeHandler.act;

    var update = function update() {
      if (ctx.type === _constant.CC_HOOK) {
        ctx.__boundSetState(newState); // 保持和class组件callback一样的行为，即组件渲染后再触发callback


        setTimeout(cbNewState, 0);
      } else {
        // 此处注意原始的react class setSate [,callback] 不会提供latestState
        ctx.__boundSetState(partialState, cbNewState);
      }
    }; // for rest-test-utils


    if (act) act(update);else update();
  };
};

exports.makeRefSetState = makeRefSetState;

var makeRefForceUpdate = function makeRefForceUpdate(ref) {
  return function (cb) {
    var ctx = ref.ctx;
    var newState = Object.assign({}, ctx.unProxyState, ctx.__$$mstate);

    var cbNewState = function cbNewState() {
      return cb && cb(newState);
    };

    if (ctx.type === _constant.CC_HOOK) {
      ctx.__boundSetState(newState);

      cbNewState();
    } else {
      ctx.__boundForceUpdate(cbNewState);
    }
  };
};

exports.makeRefForceUpdate = makeRefForceUpdate;