"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = _default;

var _ccContext = _interopRequireDefault(require("../../cc-context"));

var _constant = require("../../support/constant");

var util = _interopRequireWildcard(require("../../support/util"));

var checker = _interopRequireWildcard(require("../param/checker"));

var _guessDuplicate = _interopRequireDefault(require("../base/guess-duplicate"));

var refCache = _interopRequireWildcard(require("../ref/_cache"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var safeAssignToMap = util.safeAssignToMap,
    okeys = util.okeys,
    safeGet = util.safeGet;

function _default(module, mState, moduleMustNotExisted, innerParams) {
  if (moduleMustNotExisted === void 0) {
    moduleMustNotExisted = true;
  }

  // force MODULE_VOID state as {}
  var state = module === _constant.MODULE_VOID ? {} : mState;

  try {
    checker.checkModuleNameAndState(module, state, moduleMustNotExisted, innerParams);
  } catch (err) {
    (0, _guessDuplicate["default"])(err, module, 'state');
  }

  refCache.createModuleNode(module);
  var ccStore = _ccContext["default"].store;
  var rootState = ccStore.getState();
  var rootStateVer = ccStore.getStateVer();
  var rootModuleVer = ccStore.getModuleVer();
  var prevRootState = ccStore.getPrevState();
  safeAssignToMap(rootState, module, state);
  safeAssignToMap(prevRootState, module, state);
  rootStateVer[module] = okeys(state).reduce(function (map, key) {
    map[key] = 1;
    return map;
  }, {});
  rootModuleVer[module] = 1; // 把_computedValueOri safeGet从init-module-computed调整到此处
  // 防止用户不定义任何computed，而只是定义watch时报错undefined

  var cu = _ccContext["default"].computed;
  safeGet(cu._computedDep, module, util.makeCuDepDesc());
  safeGet(cu._computedValues, module);
  safeGet(cu._computedRawValues, module);
  var stateKeys = okeys(state);
  _ccContext["default"].moduleName2stateKeys[module] = stateKeys;

  if (module === _constant.MODULE_GLOBAL) {
    var globalStateKeys = _ccContext["default"].globalStateKeys;
    stateKeys.forEach(function (key) {
      if (!globalStateKeys.includes(key)) globalStateKeys.push(key);
    });
  }

  _ccContext["default"].module2insCount[module] = 0;
}