"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = _default;

var _ccContext = _interopRequireDefault(require("../../cc-context"));

var util = _interopRequireWildcard(require("../../support/util"));

var _privConstant = require("../../support/priv-constant");

var _constant = require("../../support/constant");

var _configureDepFns = _interopRequireDefault(require("../base/configure-dep-fns"));

var _findDepFnsToExecute = _interopRequireDefault(require("../base/find-dep-fns-to-execute"));

var _pickDepFns = _interopRequireDefault(require("../base/pick-dep-fns"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var isPJO = util.isPJO,
    safeGet = util.safeGet,
    okeys = util.okeys;
/**
 * 设置watch值，过滤掉一些无效的key
 */

function _default(module, moduleWatch, append) {
  if (moduleWatch === void 0) {
    moduleWatch = {};
  }

  if (append === void 0) {
    append = false;
  }

  if (!isPJO(moduleWatch)) {
    throw new Error("module[" + module + "] watch " + _privConstant.INAJ);
  }

  var rootWatchDep = _ccContext["default"].watch.getRootWatchDep();

  var rootWatchRaw = _ccContext["default"].watch.getRootWatchRaw();

  var rootComputedValue = _ccContext["default"].computed.getRootComputedValue();

  if (append) {
    var ori = rootWatchRaw[module];
    if (ori) Object.assign(ori, moduleWatch);else rootWatchRaw[module] = moduleWatch;
  } else {
    rootWatchRaw[module] = moduleWatch;
  }

  var getState = _ccContext["default"].store.getState;
  var moduleState = getState(module);
  (0, _configureDepFns["default"])(_constant.CATE_MODULE, {
    module: module,
    stateKeys: okeys(moduleState),
    dep: rootWatchDep
  }, moduleWatch);

  var d = _ccContext["default"].getDispatcher();

  var curDepWatchFns = function curDepWatchFns(committedState, isFirstCall) {
    return (0, _pickDepFns["default"])(isFirstCall, _constant.CATE_MODULE, _constant.FN_WATCH, rootWatchDep, module, moduleState, committedState);
  };

  var moduleComputedValue = safeGet(rootComputedValue, module);
  (0, _findDepFnsToExecute["default"])(d, module, d && d.ctx.module, moduleState, curDepWatchFns, moduleState, moduleState, moduleState, util.makeCallInfo(module), true, _constant.FN_WATCH, _constant.CATE_MODULE, moduleComputedValue);
}